searchNodes=[{"doc":"Elixir programming language plugin management system Build purpose Imagine you are going to make an application that will have many plugins built for it in the future. But the fact that many manipulations will be made on your source code makes it difficult to maintain the application. For example, you present a content management system for your users, and now they need to activate a section for registration and SMS ; the system allows you to present your desired input/output absolutely plugin oriented to your users and makes it possible for the developers to write their required applications beyond the core source code. We have used this library in the Mishka content management system . NOTICE: Do not use the master branch; this library is under heavy development. Expect version 0.0.4, and for using the new features, please wait until a new release is out. Plugin management system theory and installation of Elixir libraries at runtime The functionality of this library can be conceptualized as an architectural potential that is composed of two primary components, which are as follows: Event management Managing removal and installation of Elixir plugins without downtime . When a programmer uses this library for his own software development, we sought to ensure that in addition to the established capabilities, he also has access to a set of appropriate standards for software development that are based on preset behaviors that can be applied. This was our goal. It streamlines and organizes the work of a group working on a project while also facilitating the creation of software. Error control and tree structure, which enable us to develop a system that is robust and trustworthy, are two of the guiding ideas behind the construction of this library, which has garnered attention from people all around the world. The MishkaInstaller library can be created in various systems, and it provides fundamental capabilities such as the management of plugin states and the application of standard behaviors. These features can all be accessed by specified hooks in the library. Behaviors and events In this section, you can define a series of events for each event , for example: after successful registration or unsuccessful purchase from “the store”, and for each event , put a set of callbacks in one module. After completing this step, when the user wants to create his own plugin, the @behaviour module will call you in its action module. This helps you have a regular and error-free system, and the library uses an almost integrated structure in all of its events. Hook with priority In Mishka Elixir Plugin Management Library, a series of action or hook functions are given to the developer of the main plugin or software, which helps build plugins outside the system and convert software sections into separate events . Some of the functions of this module include the following: Registering a plugin outside of the system in database and ram state Removing plugin from database and state Restoring plugin Successful pause of plugin Hook plugin Search among the events And other functions that help both the mother software become an event-driven system and the developer can build the desired plugin or extension for different parts of the software and install it on the system as a separate package. This package can also be published in hex . State management and links to the database supporting PostgreSQL The Hook module manages a large part of this part, and the developer of the external plugin usually does not need it much. Still, this part creates a state on RAM for each plugin that is activated in a specific event and a dynamic supervisor for it. This allows us in case of an error in each plugin; the other plugins in the different events face no errors, and the system will try to restart with various strategies. It should be noted for more stability and data storage after registering a plugin in the system; This section also maintains a backup copy of the database and strategies for recall in the event in case of an error. But to speed up the calling of each plugin, the website always uses state . Managing removal and installation of Elixir plugins without downtime Through the use of event management, you are able to convert any portion of your program into a standalone event based on the specific requirements of the strategy, and you are also able to activate an endless number of modules or plugins for each event. However, if you do not perform installation at runtime, you will need to ensure that you call all of the necessary plugins in addition to the primary source when you start the software. One example of this would be installing an Elixir library in the mix.exs file. By utilizing this capability, you will be able to add your program to the system and manage it after adding it, even if your software is already operating. The following are examples of management facilities that may be included: Register a plugin for a specified event Activate the plugin for the installation Put an end to the installation of plugins Resetting the configuration plugin used during installation Uninstall the currently active plugin. Manage the plugin's requirements after they have been installed. Keeping an eye on the graphic panel and demonstrating it to the site managers And there are other scenarios that are known as APIs or Hooks to the software developer and management, and making use of them is a pretty straightforward process. It is important to note that this capability does not involve Erlang's hot coding and that it can only be used to install an Elixir library. Additionally, it is still in the process of being developed and is now in an experimental stage. If you use the software, you need to make sure you have a backup of it. At the moment, it is merely in the testing phase of its development, which consists of trial and error. To use this section, please read the documentation of this library Installing the library: It should be noted that this library must be installed in two parts of the plugin and the software that wants to display the plugins, and due to its small dependencies, it does not cause any problems. To install, just add this library to your &quot;mix.exs&quot; in the &quot;deps&quot; function as follows: def deps do [ { :mishka_installer , &quot;~&gt; 0.0.4&quot; } ] end Using the library for extension creation and event activation: After installing this library, you must first install the required database of this package on your website, for which a mix task has been created, which is enough to load it once in your terminal, in the project path before the start. mix mishka_installer . db . gen . migration After implementing the above sections, you must first implement events in your main software and place the call function from the Hook module there to call all the plugins activated in the event you want based on priority. And give the state you want, to these plugins in order, and the output you expect will eventually be generated. For example, you can see the mentioned description in a function controller in phoenix after a successful registration as the following: def login ( conn , %{ &quot;user&quot; =&gt; %{ &quot;email&quot; =&gt; email , &quot;password&quot; =&gt; password } } = _params ) do # If your conditions are passed we call an event and pass it a struct of entries # which our developers need to create plugin with this information state = % MishkaInstaller.Reference.OnUserAfterLogin { conn : conn , endpoint : :html , ip : user_ip , type : :email , user_info : user_info } hook = MishkaInstaller.Hook . call ( event : &quot;on_user_after_login&quot; , state : state ) hook . conn |&gt; renew_session ( ) |&gt; put_session ( :user_id , user_info . id ) |&gt; put_flash ( :info , &quot;You entered to our world, well played.&quot; ) |&gt; redirect ( to : &quot;/home&quot; ) end Now the event is ready in the part where you need to allow the developer to make his own plugins for it. And it's time to write a plugin for this section. This is very simple. Consider the following example: defmodule MishkaUser.SuccessLogin do alias MishkaInstaller.Reference.OnUserAfterLogin use MishkaInstaller.Hook , module : __MODULE__ , behaviour : OnUserAfterLogin , event : :on_user_after_login , initial : [ ] @spec initial ( list ( ) ) :: { :ok , OnUserAfterLogin . ref ( ) , list ( ) } def initial ( args ) do event = % PluginState { name : &quot;MishkaUser.SuccessLogin&quot; , event : Atom . to_string ( @ref ) , priority : 1 } Hook . register ( event : event ) { :ok , @ref , args } end @spec call ( OnUserAfterLogin . t ( ) ) :: { :reply , OnUserAfterLogin . t ( ) } def call ( % OnUserAfterLogin { } = state ) do new_state = Your_Code_Or_Function { :reply , new_state } end end As you can see in the above, we used MishkaInstaller.Reference.OnUserAfterLogin in order to activate behavior which has a few callback in it, and you can see here . There should be two main functions in each plugin, namely initial and also call . In the first function, we introduce our plugin, and in the second function, whenever the action function calls this special event for which the plugin is written, based on priority. This plugin is also called. But what is important is the final output of the call function. This output may be the input of other plugins with higher priorities. The order of the plugins is from small to large, and if several plugins are registered for a number, it is sorted by name in the second parameter. And it should be noted that in any case, if you did not want this state to go to other plugins and the last output is returned in the same plugin, and you can replace {:reply, :halt, new_state} with {:reply, new_state} . Subsequent plugins with higher priorities are not counted, and the loop ends here. Notice that a Genserver will be made based on each plugin name without a supervisor, which can be used for temporary memory in the case when the __using__ function is used as above, which results in the following option: use MishkaInstaller.Hook , module : __MODULE__ , behaviour : OnUserAfterLogin , event : :on_user_after_login , initial : [ ] The last two step to use the plugin you have to put it in your Application module so that whenever the server is turned off and on, the plugin is run again and if it is not registered, a copy of its support will be provided once in the database. children = [ %{ id : YOUR_PLUGIN_MODULE , start : { YOUR_PLUGIN_MODULE , :start_link , [ [ ] ] } } ] And add these config in your project like /config/config.exs config :mishka_installer , :basic , repo : YOUR_Repo , pubsub : YOUR_PUBSUB or nil , html_router : YOUR_WEBSITE_ROUTER_MODULE , project_path : YOUR_PROJECT_PATH , mix : YOUR_MIX_MODULE , mix_path : YOUR_MIX_EXS_PATH , gettext : YOUR_GETTEXT Because there are a lot of moving elements in this plugin, you need to read the documentation before using it. You can see our recommendations and other colleagues in the Proposal repository, and if you have a request or idea, send us the full description. Please help us by submitting suggestions and reviewing the project so that Mishka Group can produce more products and provide them to programmers and webmasters, and online software.","ref":"MishkaInstaller.html","title":"MishkaInstaller","type":"module"},{"doc":"","ref":"MishkaInstaller.html#checksum/1","title":"MishkaInstaller.checksum/1","type":"function"},{"doc":"","ref":"MishkaInstaller.html#dependency_activity/3","title":"MishkaInstaller.dependency_activity/3","type":"function"},{"doc":"","ref":"MishkaInstaller.html#ensure_compiled/1","title":"MishkaInstaller.ensure_compiled/1","type":"function"},{"doc":"","ref":"MishkaInstaller.html#get_config/2","title":"MishkaInstaller.get_config/2","type":"function"},{"doc":"","ref":"MishkaInstaller.html#gettext/0","title":"MishkaInstaller.gettext/0","type":"function"},{"doc":"","ref":"MishkaInstaller.html#ip/1","title":"MishkaInstaller.ip/1","type":"function"},{"doc":"","ref":"MishkaInstaller.html#plugin_activity/4","title":"MishkaInstaller.plugin_activity/4","type":"function"},{"doc":"","ref":"MishkaInstaller.html#repo/0","title":"MishkaInstaller.repo/0","type":"function"},{"doc":"","ref":"MishkaInstaller.html#start_oban_in_runtime/1","title":"MishkaInstaller.start_oban_in_runtime/1","type":"function"},{"doc":"","ref":"MishkaInstaller.html#trim_url/1","title":"MishkaInstaller.trim_url/1","type":"function"},{"doc":"","ref":"MishkaInstaller.html#update_activity/3","title":"MishkaInstaller.update_activity/3","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesActionEnum.html","title":"MishkaInstaller.ActivitiesActionEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.ActivitiesActionEnum.html#cast/1","title":"MishkaInstaller.ActivitiesActionEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.ActivitiesActionEnum.html#dump/1","title":"MishkaInstaller.ActivitiesActionEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.ActivitiesActionEnum.html#embed_as/1","title":"MishkaInstaller.ActivitiesActionEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.ActivitiesActionEnum.html#equal?/2","title":"MishkaInstaller.ActivitiesActionEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.ActivitiesActionEnum.html#load/1","title":"MishkaInstaller.ActivitiesActionEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.ActivitiesActionEnum.html#type/0","title":"MishkaInstaller.ActivitiesActionEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesActionEnum.html#valid_value?/1","title":"MishkaInstaller.ActivitiesActionEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesActionEnum.html#t:t/0","title":"MishkaInstaller.ActivitiesActionEnum.t/0","type":"type"},{"doc":"","ref":"MishkaInstaller.ActivitiesSectionEnum.html","title":"MishkaInstaller.ActivitiesSectionEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.ActivitiesSectionEnum.html#cast/1","title":"MishkaInstaller.ActivitiesSectionEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.ActivitiesSectionEnum.html#dump/1","title":"MishkaInstaller.ActivitiesSectionEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.ActivitiesSectionEnum.html#embed_as/1","title":"MishkaInstaller.ActivitiesSectionEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.ActivitiesSectionEnum.html#equal?/2","title":"MishkaInstaller.ActivitiesSectionEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.ActivitiesSectionEnum.html#load/1","title":"MishkaInstaller.ActivitiesSectionEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.ActivitiesSectionEnum.html#type/0","title":"MishkaInstaller.ActivitiesSectionEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesSectionEnum.html#valid_value?/1","title":"MishkaInstaller.ActivitiesSectionEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesSectionEnum.html#t:t/0","title":"MishkaInstaller.ActivitiesSectionEnum.t/0","type":"type"},{"doc":"","ref":"MishkaInstaller.ActivitiesStatusEnum.html","title":"MishkaInstaller.ActivitiesStatusEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.ActivitiesStatusEnum.html#cast/1","title":"MishkaInstaller.ActivitiesStatusEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.ActivitiesStatusEnum.html#dump/1","title":"MishkaInstaller.ActivitiesStatusEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.ActivitiesStatusEnum.html#embed_as/1","title":"MishkaInstaller.ActivitiesStatusEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.ActivitiesStatusEnum.html#equal?/2","title":"MishkaInstaller.ActivitiesStatusEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.ActivitiesStatusEnum.html#load/1","title":"MishkaInstaller.ActivitiesStatusEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.ActivitiesStatusEnum.html#type/0","title":"MishkaInstaller.ActivitiesStatusEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesStatusEnum.html#valid_value?/1","title":"MishkaInstaller.ActivitiesStatusEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesStatusEnum.html#t:t/0","title":"MishkaInstaller.ActivitiesStatusEnum.t/0","type":"type"},{"doc":"","ref":"MishkaInstaller.ActivitiesTypeEnum.html","title":"MishkaInstaller.ActivitiesTypeEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.ActivitiesTypeEnum.html#cast/1","title":"MishkaInstaller.ActivitiesTypeEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.ActivitiesTypeEnum.html#dump/1","title":"MishkaInstaller.ActivitiesTypeEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.ActivitiesTypeEnum.html#embed_as/1","title":"MishkaInstaller.ActivitiesTypeEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.ActivitiesTypeEnum.html#equal?/2","title":"MishkaInstaller.ActivitiesTypeEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.ActivitiesTypeEnum.html#load/1","title":"MishkaInstaller.ActivitiesTypeEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.ActivitiesTypeEnum.html#type/0","title":"MishkaInstaller.ActivitiesTypeEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesTypeEnum.html#valid_value?/1","title":"MishkaInstaller.ActivitiesTypeEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.ActivitiesTypeEnum.html#t:t/0","title":"MishkaInstaller.ActivitiesTypeEnum.t/0","type":"type"},{"doc":"This module is for communication with Activities table and has essential functions such as adding, editing, deleting, and displaying. This module is related to module MishkaInstaller.Database.ActivitySchema .","ref":"MishkaInstaller.Activity.html","title":"MishkaInstaller.Activity","type":"module"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.create/1 .","ref":"MishkaInstaller.Activity.html#create/1","title":"MishkaInstaller.Activity.create/1","type":"function"},{"doc":"This function helps to save the latest activities in different nodes without waiting for a response.","ref":"MishkaInstaller.Activity.html#create_activity_by_start_child/2","title":"MishkaInstaller.Activity.create_activity_by_start_child/2","type":"function"},{"doc":"This function helps to save the latest activities in different nodes within waiting for a response.","ref":"MishkaInstaller.Activity.html#create_activity_by_task/2","title":"MishkaInstaller.Activity.create_activity_by_task/2","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.delete/1 .","ref":"MishkaInstaller.Activity.html#delete/1","title":"MishkaInstaller.Activity.delete/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.edit/1 .","ref":"MishkaInstaller.Activity.html#edit/1","title":"MishkaInstaller.Activity.edit/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_edit/1 .","ref":"MishkaInstaller.Activity.html#edit/2","title":"MishkaInstaller.Activity.edit/2","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.show_by_id/1 .","ref":"MishkaInstaller.Activity.html#show_by_id/1","title":"MishkaInstaller.Activity.show_by_id/1","type":"function"},{"doc":"If you want to get the latest changes from the Activities table of your database, this function can help you to be subscribed.","ref":"MishkaInstaller.Activity.html#subscribe/0","title":"MishkaInstaller.Activity.subscribe/0","type":"function"},{"doc":"","ref":"MishkaInstaller.ContentPriorityEnum.html","title":"MishkaInstaller.ContentPriorityEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.ContentPriorityEnum.html#cast/1","title":"MishkaInstaller.ContentPriorityEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.ContentPriorityEnum.html#dump/1","title":"MishkaInstaller.ContentPriorityEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.ContentPriorityEnum.html#embed_as/1","title":"MishkaInstaller.ContentPriorityEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.ContentPriorityEnum.html#equal?/2","title":"MishkaInstaller.ContentPriorityEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.ContentPriorityEnum.html#load/1","title":"MishkaInstaller.ContentPriorityEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.ContentPriorityEnum.html#type/0","title":"MishkaInstaller.ContentPriorityEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.ContentPriorityEnum.html#valid_value?/1","title":"MishkaInstaller.ContentPriorityEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.ContentPriorityEnum.html#t:t/0","title":"MishkaInstaller.ContentPriorityEnum.t/0","type":"type"},{"doc":"This module has been implemented to create the Activities table schema.","ref":"MishkaInstaller.Database.ActivitySchema.html","title":"MishkaInstaller.Database.ActivitySchema","type":"module"},{"doc":"","ref":"MishkaInstaller.Database.ActivitySchema.html#changeset/2","title":"MishkaInstaller.Database.ActivitySchema.changeset/2","type":"function"},{"doc":"This module has been implemented to create the Dependencies table schema.","ref":"MishkaInstaller.Database.DependencySchema.html","title":"MishkaInstaller.Database.DependencySchema","type":"module"},{"doc":"","ref":"MishkaInstaller.Database.DependencySchema.html#changeset/2","title":"MishkaInstaller.Database.DependencySchema.changeset/2","type":"function"},{"doc":"This module provides some functions as utility tools to work with a database and other things.","ref":"MishkaInstaller.Database.Helper.html","title":"MishkaInstaller.Database.Helper","type":"module"},{"doc":"Helper function to keep PID alive for testing Genserver and database. Reference https://elixirforum.com/t/how-to-send-sandbox-allow-for-each-dynamic-supervisor-testing/46422/4 Examples MishkaInstaller.Database.Helper . allow_if_sandbox ( pid )","ref":"MishkaInstaller.Database.Helper.html#allow_if_sandbox/2","title":"MishkaInstaller.Database.Helper.allow_if_sandbox/2","type":"function"},{"doc":"Converting string map to atom map. Examples MishkaInstaller.Database.Helper . convert_string_map_to_atom_map ( %{ &quot;name&quot; =&gt; &quot;Mishka&quot; } )","ref":"MishkaInstaller.Database.Helper.html#convert_string_map_to_atom_map/1","title":"MishkaInstaller.Database.Helper.convert_string_map_to_atom_map/1","type":"function"},{"doc":"If you need to convert database errors into a list, this function can be helpful. One of its uses can be correcting returned errors from the database into a list and converting it into JSON. Examples MishkaInstaller.Database.Helper . translate_errors ( changeset )","ref":"MishkaInstaller.Database.Helper.html#translate_errors/1","title":"MishkaInstaller.Database.Helper.translate_errors/1","type":"function"},{"doc":"UUID validation. Examples MishkaInstaller.Database.Helper . uuid ( 12 ) # OR MishkaInstaller.Database.Helper . uuid ( &quot;8c512ac2-e002-4589-a93f-b479e46c249d&quot; )","ref":"MishkaInstaller.Database.Helper.html#uuid/1","title":"MishkaInstaller.Database.Helper.uuid/1","type":"function"},{"doc":"UUID validation for ecto schema. Examples MishkaInstaller.Database.Helper . validate_binary_id ( 12 ) # OR MishkaInstaller.Database.Helper . validate_binary_id ( &quot;8c512ac2-e002-4589-a93f-b479e46c249d&quot; )","ref":"MishkaInstaller.Database.Helper.html#validate_binary_id/3","title":"MishkaInstaller.Database.Helper.validate_binary_id/3","type":"function"},{"doc":"This module has been implemented to create the Plugins table schema.","ref":"MishkaInstaller.Database.PluginSchema.html","title":"MishkaInstaller.Database.PluginSchema","type":"module"},{"doc":"","ref":"MishkaInstaller.Database.PluginSchema.html#changeset/2","title":"MishkaInstaller.Database.PluginSchema.changeset/2","type":"function"},{"doc":"This module has been implemented to create the Settings table schema.","ref":"MishkaInstaller.Database.SettingSchema.html","title":"MishkaInstaller.Database.SettingSchema","type":"module"},{"doc":"","ref":"MishkaInstaller.Database.SettingSchema.html#changeset/2","title":"MishkaInstaller.Database.SettingSchema.changeset/2","type":"function"},{"doc":"With the assistance of this module, you will be able to construct a queue to process and install extensions. This module's responsibility includes reactivating the queue using the MishkaInstaller.Installer.DepChangesProtector module as one of its tasks.","ref":"MishkaInstaller.DepCompileJob.html","title":"MishkaInstaller.DepCompileJob","type":"module"},{"doc":"Register an extension to the compiling queue. With the assistance of this function, you will be able to construct a queue, download and upload plugins in a sequential fashion from a variety of sources, and register them in your system. Examples MishkaInstaller.DepCompileJob . add_job ( &quot;mishka_installer&quot; , :cmd ) # or MishkaInstaller.DepCompileJob . add_job ( &quot;mishka_installer&quot; , :port )","ref":"MishkaInstaller.DepCompileJob.html#add_job/2","title":"MishkaInstaller.DepCompileJob.add_job/2","type":"function"},{"doc":"This module provides assistance to your software so that it may check all of the plugins and libraries that you have installed to see whether a newer version of those extensions has been made available.","ref":"MishkaInstaller.DepUpdateJob.html","title":"MishkaInstaller.DepUpdateJob","type":"module"},{"doc":"Check and find new updates of extensions if new releases exist. This function just returns :ok atom and saves update news into ETS. Examples MishkaInstaller.DepUpdateJob . check_added_dependencies_update ( )","ref":"MishkaInstaller.DepUpdateJob.html#check_added_dependencies_update/0","title":"MishkaInstaller.DepUpdateJob.check_added_dependencies_update/0","type":"function"},{"doc":"Start ETS table to store new updates of installed extensions. Examples MishkaInstaller.DepUpdateJob . ets ( )","ref":"MishkaInstaller.DepUpdateJob.html#ets/0","title":"MishkaInstaller.DepUpdateJob.ets/0","type":"function"},{"doc":"Get new release information of an extension. Examples MishkaInstaller.DepUpdateJob . get ( &quot;test_app&quot; )","ref":"MishkaInstaller.DepUpdateJob.html#get/1","title":"MishkaInstaller.DepUpdateJob.get/1","type":"function"},{"doc":"Get new releases information of extensions. Examples MishkaInstaller.DepUpdateJob . get_all ( )","ref":"MishkaInstaller.DepUpdateJob.html#get_all/0","title":"MishkaInstaller.DepUpdateJob.get_all/0","type":"function"},{"doc":"This function provides a channel to get new updates of extension releases; your project can subscribe and use this information. Examples MishkaInstaller.DepUpdateJob . subscribe ( )","ref":"MishkaInstaller.DepUpdateJob.html#subscribe/0","title":"MishkaInstaller.DepUpdateJob.subscribe/0","type":"function"},{"doc":"This module is for communication with Dependencies table and has essential functions such as adding, editing, deleting, and displaying. This module is related to module MishkaInstaller.Database.DependencySchema .","ref":"MishkaInstaller.Dependency.html","title":"MishkaInstaller.Dependency","type":"module"},{"doc":"This is an aggregation function that includes editing a type of app.","ref":"MishkaInstaller.Dependency.html#change_dependency_type_with_app/2","title":"MishkaInstaller.Dependency.change_dependency_type_with_app/2","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.create/1 .","ref":"MishkaInstaller.Dependency.html#create/1","title":"MishkaInstaller.Dependency.create/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_add/1 .","ref":"MishkaInstaller.Dependency.html#create/2","title":"MishkaInstaller.Dependency.create/2","type":"function"},{"doc":"This is an aggregation function that includes editing or adding.","ref":"MishkaInstaller.Dependency.html#create_or_update/1","title":"MishkaInstaller.Dependency.create_or_update/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.delete/1 .","ref":"MishkaInstaller.Dependency.html#delete/1","title":"MishkaInstaller.Dependency.delete/1","type":"function"},{"doc":"Show all dependencies.","ref":"MishkaInstaller.Dependency.html#dependencies/0","title":"MishkaInstaller.Dependency.dependencies/0","type":"function"},{"doc":"","ref":"MishkaInstaller.Dependency.html#dependencies/1","title":"MishkaInstaller.Dependency.dependencies/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.edit/1 .","ref":"MishkaInstaller.Dependency.html#edit/1","title":"MishkaInstaller.Dependency.edit/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_edit/1 .","ref":"MishkaInstaller.Dependency.html#edit/2","title":"MishkaInstaller.Dependency.edit/2","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.show_by_id/1 .","ref":"MishkaInstaller.Dependency.html#show_by_id/1","title":"MishkaInstaller.Dependency.show_by_id/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_get_by_field/2 .","ref":"MishkaInstaller.Dependency.html#show_by_name/1","title":"MishkaInstaller.Dependency.show_by_name/1","type":"function"},{"doc":"If you want to get the latest changes from the Dependencies table of your database, this function can help you to be subscribed.","ref":"MishkaInstaller.Dependency.html#subscribe/0","title":"MishkaInstaller.Dependency.subscribe/0","type":"function"},{"doc":"","ref":"MishkaInstaller.DependencyEnum.html","title":"MishkaInstaller.DependencyEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.DependencyEnum.html#cast/1","title":"MishkaInstaller.DependencyEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.DependencyEnum.html#dump/1","title":"MishkaInstaller.DependencyEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.DependencyEnum.html#embed_as/1","title":"MishkaInstaller.DependencyEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.DependencyEnum.html#equal?/2","title":"MishkaInstaller.DependencyEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.DependencyEnum.html#load/1","title":"MishkaInstaller.DependencyEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.DependencyEnum.html#type/0","title":"MishkaInstaller.DependencyEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.DependencyEnum.html#valid_value?/1","title":"MishkaInstaller.DependencyEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.DependencyEnum.html#t:t/0","title":"MishkaInstaller.DependencyEnum.t/0","type":"type"},{"doc":"","ref":"MishkaInstaller.DependencyTypeEnum.html","title":"MishkaInstaller.DependencyTypeEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.DependencyTypeEnum.html#cast/1","title":"MishkaInstaller.DependencyTypeEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.DependencyTypeEnum.html#dump/1","title":"MishkaInstaller.DependencyTypeEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.DependencyTypeEnum.html#embed_as/1","title":"MishkaInstaller.DependencyTypeEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.DependencyTypeEnum.html#equal?/2","title":"MishkaInstaller.DependencyTypeEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.DependencyTypeEnum.html#load/1","title":"MishkaInstaller.DependencyTypeEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.DependencyTypeEnum.html#type/0","title":"MishkaInstaller.DependencyTypeEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.DependencyTypeEnum.html#valid_value?/1","title":"MishkaInstaller.DependencyTypeEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.DependencyTypeEnum.html#t:t/0","title":"MishkaInstaller.DependencyTypeEnum.t/0","type":"type"},{"doc":"You can find some utility functions in this module. It will be merged with the other helper module.","ref":"MishkaInstaller.Helper.Extra.html","title":"MishkaInstaller.Helper.Extra","type":"module"},{"doc":"With this function, you can extract some basic information from a mix file by AST. Examples MishkaInstaller.Helper.Extra . ast_mix_file_basic_information ( ast , [ :app , :version , :source_url ] , [ { :tag , tag } ] ) Reference https://elixirforum.com/t/getting-basic-information-of-a-elixir-project-from-github/48231/7","ref":"MishkaInstaller.Helper.Extra.html#ast_mix_file_basic_information/3","title":"MishkaInstaller.Helper.Extra.ast_mix_file_basic_information/3","type":"function"},{"doc":"You can find some utility functions in this module which help you to download dependencies from Hex and GitHub and prepare them as library. Testing resource MishkaInstaller.Helper.Sender.package(&quot;hex&quot;, %{&quot;app&quot; =&gt; &quot;req&quot;}) https://hex.pm/api/packages/req/releases/0.1.0 https://api.github.com/repos/mishka-group/mishka_installer/tarball/0.0.3 https://stackoverflow.com/questions/30267943/elixir-download-a-file-image-from-a-url","ref":"MishkaInstaller.Helper.LibraryMaker.html","title":"MishkaInstaller.Helper.LibraryMaker","type":"module"},{"doc":"","ref":"MishkaInstaller.Helper.LibraryMaker.html#change_uploaded_file/2","title":"MishkaInstaller.Helper.LibraryMaker.change_uploaded_file/2","type":"function"},{"doc":"A function which download a package from Hex/Github and save it in the deployment/extensions folder.","ref":"MishkaInstaller.Helper.LibraryMaker.html#download/3","title":"MishkaInstaller.Helper.LibraryMaker.download/3","type":"function"},{"doc":"","ref":"MishkaInstaller.Helper.LibraryMaker.html#extract/2","title":"MishkaInstaller.Helper.LibraryMaker.extract/2","type":"function"},{"doc":"","ref":"MishkaInstaller.Helper.LibraryMaker.html#run/3","title":"MishkaInstaller.Helper.LibraryMaker.run/3","type":"function"},{"doc":"To begin, we look at the hex.pm website in an effort to get some fundamental information. Despite this, after several versions of MishkaInstaller have been released, this API may prove to be helpful for managing packages from within an administrative panel. Reference https://github.com/hexpm/hexpm/issues/1124","ref":"MishkaInstaller.Helper.Sender.html","title":"MishkaInstaller.Helper.Sender","type":"module"},{"doc":"This is an executor function and has several different modes, including: Get information from hex.pm website Getting information from GitHub Getting information from the latest GitHub releases Get information from the latest GitHub tags Examples MishkaInstaller.Helper.Sender . package ( &quot;hex&quot; , %{ &quot;app&quot; =&gt; app } ) # or MishkaInstaller.Helper.Sender . package ( &quot;github&quot; , %{ &quot;url&quot; =&gt; app . url , &quot;tag&quot; =&gt; app . tag } ) # or MishkaInstaller.Helper.Sender . package ( &quot;github_latest_release&quot; , json_data [ &quot;url&quot; ] ) # or MishkaInstaller.Helper.Sender . package ( &quot;github_latest_tag&quot; , json_data [ &quot;url&quot; ] )","ref":"MishkaInstaller.Helper.Sender.html#package/2","title":"MishkaInstaller.Helper.Sender.package/2","type":"function"},{"doc":"","ref":"MishkaInstaller.Helper.Sender.html#t:app/0","title":"MishkaInstaller.Helper.Sender.app/0","type":"type"},{"doc":"This module offers a number of necessary functions that can be used to access the runtime configuration. The owner of the system has the ability to make changes to these parameters, which will then be updated in the database. This section was formerly a part of MishkaCMS , and the accompanying system is likewise a very straightforward one for saving particular settings when the system is being executed. Note : that the functionality of this section is not restricted to the 'MishkaInstaller' section; rather, it can be utilized in other parts of your product.","ref":"MishkaInstaller.Helper.Setting.html","title":"MishkaInstaller.Helper.Setting","type":"module"},{"doc":"","ref":"MishkaInstaller.Helper.Setting.html#delete/1","title":"MishkaInstaller.Helper.Setting.delete/1","type":"function"},{"doc":"Get your required configs from ETS.","ref":"MishkaInstaller.Helper.Setting.html#get/1","title":"MishkaInstaller.Helper.Setting.get/1","type":"function"},{"doc":"Get All your required configs from ETS.","ref":"MishkaInstaller.Helper.Setting.html#get_all/0","title":"MishkaInstaller.Helper.Setting.get_all/0","type":"function"},{"doc":"Push your required configs to ETS.","ref":"MishkaInstaller.Helper.Setting.html#push/1","title":"MishkaInstaller.Helper.Setting.push/1","type":"function"},{"doc":"Start the ETS table :setting_ets_state and sync with the settings table in the Postgres database.","ref":"MishkaInstaller.Helper.Setting.html#start_link/1","title":"MishkaInstaller.Helper.Setting.start_link/1","type":"function"},{"doc":"Sync the ETS config table with your database.","ref":"MishkaInstaller.Helper.Setting.html#sync_with_database/0","title":"MishkaInstaller.Helper.Setting.sync_with_database/0","type":"function"},{"doc":"In addition to being one of the most significant modules of the MishkaInstaller library, the Hook module gives you the ability to make the library as a whole, as well as the projects that make use of this library, more modular. It is essential to comprehend that you may treat any action performed independently as an event and register an unlimited number of plugins for that event. You can do this by considering that action to be done separately. Each plugin has the potential to have its own individual inputs and outputs, and depending on the architecture of the area that you want to use Hook in, you may even be able to change the output and send it to other plugins. Throughout all of the many parts that have been built for this module, it has been attempted to have a flexible approach to dealing with errors and to provide the programmer with a wide variety of options. With the additional functions at her disposal, the programmer can actually create a gateway in their projects, where the data flow must pass through several gates, whether it changes or remains unchanged, and a series of operations are performed. For illustration's sake, let's suppose you want the registration system to allow users to sign up for social networks on Twitter and Google. When you use this library, it is conceivable that you can quickly display HTML or even operate in the background before registering after registering. This is a significant improvement over the standard practice, in which you are required to modify the primary codes of your project. Create a separate plugin. It is interesting to notice that these facilities are quite basic and convenient for the admin user. If this opportunity is provided, the management can manage its own plugins in different ways if it has a dashboard. It is crucial to highlight that each plugin is its own GenServer ; in addition, it is dynamically supervised, and the information is stored in the database as well as in ETS. Furthermore, this section is very useful even if the programmer wants to perform many tasks that are not associated with Perform defined functions. The fact that the programmers have to introduce each plugin to the system based on a specific behavior is one of the exciting aspects of using this section. Additionally, the system has prepared some default behaviors to force the programmers to introduce the plugins in the order specified by the system. The use of custom behaviors on the part of the programmer and MishkaInstaller itself makes debugging easier; however, this library does not leave the programmer to fend for themselves in this significant matter; rather, a straightforward error storage system is prepared based on the particular activities being performed. Should prevent any unpredictable behavior at any costs. Build purpose Imagine you are going to make an application that will have many plugins built for it in the future. But the fact that many manipulations will be made on your source code makes it difficult to maintain the application. For example, you present a content management system for your users, and now they need to activate a section for registration and SMS; the system allows you to present your desired input/output absolutely plugin oriented to your users and makes it possible for the developers to write their required applications beyond the core source code. We have used this library in the Mishka content management system . Plugin management system implementation theory The library categorizes your whole software design structure into many parts; and has an appropriate dependency that is optional with GenServer ; it considers a monitoring branch for each of your plugins, which results in fewer errors and downtime . The considered part: Behaviors and events Recalling or Hook with priority State management and links to the database ( PostgreSQL support) Except from the 1st item, which can be redefined based on the developer's needs in his/her personal systems, the remaining items are almost constant, and a lot of functions will be handed to the developer to manage each plugin. Behaviors and events In this section, you can define a series of events for each event , for example: after successful registration or unsuccessful purchase from “the store”, and for each event , put a set of callbacks in one module. After completing this step, when the user wants to create his own plugin, the @behaviour module will call you in its action module. This helps you have a regular and error-free system, and the library uses an almost integrated structure in all of its events. Hook with priority In Mishka Elixir Plugin Management Library, a series of action or hook functions are given to the developer of the main plugin or software, which helps build plugins outside the system and convert software sections into separate events . Some of the functions of this module include the following: Registering a plugin outside of the system in database and ram state Removing plugin from database and state Restoring plugin Successful pause of plugin Hook plugin Search among the events And other functions that help both the mother software become an event-driven system and the developer can build the desired plugin or extension for different parts of the software and install it on the system as a separate package. This package can also be published in hex . State management and links to the database supporting PostgreSQL The Hook module manages a large part of this part, and the developer of the external plugin usually does not need it much. Still, this part creates a state on RAM for each plugin that is activated in a specific event and a dynamic supervisor for it. This allows us in case of an error in each plugin; the other plugins in the different events face no errors, and the system will try to restart with various strategies. It should be noted for more stability and data storage after registering a plugin in the system; This section also maintains a backup copy of the database and strategies for recall in the event in case of an error. But to speed up the calling of each plugin, the website always uses state . Using the library: After installing this library, you must first install the required database of this package on your website, for which a mix task has been created, which is enough to load it once in your terminal, in the project path before the start. mix mishka_installer . db . gen . migration After implementing the above sections, you must first implement events in your main software and place the call function from the Hook module there to call all the plugins activated in the event you want based on priority. And give the state you want, to these plugins in order, and the output you expect will eventually be generated. For example, you can see the mentioned description in a function controller in phoenix after a successful registration as the following: def login ( conn , %{ &quot;user&quot; =&gt; %{ &quot;email&quot; =&gt; email , &quot;password&quot; =&gt; password } } = _params ) do # If your conditions are passed we call an event and pass it a struct of entries # which our developers need to create plugin with this information state = % MishkaInstaller.Reference.OnUserAfterLogin { conn : conn , endpoint : :html , ip : user_ip , type : :email , user_info : user_info } hook = MishkaInstaller.Hook . call ( event : &quot;on_user_after_login&quot; , state : state ) hook . conn |&gt; renew_session ( ) |&gt; put_session ( :user_id , user_info . id ) |&gt; put_flash ( :info , &quot;You entered to our world, well played.&quot; ) |&gt; redirect ( to : &quot;/home&quot; ) end Now the event is ready in the part where you need to allow the developer to make his own plugins for it. And it's time to write a plugin for this section. This is very simple. Consider the following example: defmodule MishkaUser.SuccessLogin do alias MishkaInstaller.Reference.OnUserAfterLogin use MishkaInstaller.Hook , module : __MODULE__ , behaviour : OnUserAfterLogin , event : :on_user_after_login , initial : [ ] @spec initial ( list ( ) ) :: { :ok , OnUserAfterLogin . ref ( ) , list ( ) } def initial ( args ) do event = % PluginState { name : &quot;MishkaUser.SuccessLogin&quot; , event : Atom . to_string ( @ref ) , priority : 1 } Hook . register ( event : event ) { :ok , @ref , args } end @spec call ( OnUserAfterLogin . t ( ) ) :: { :reply , OnUserAfterLogin . t ( ) } def call ( % OnUserAfterLogin { } = state ) do new_state = Your_Code_Or_Function { :reply , new_state } end end As you can see in the above, we used MishkaInstaller.Reference.OnUserAfterLogin in order to activate behavior which has a few callback in it, and you can see here . There should be two main functions in each plugin, namely initial and also call . In the first function, we introduce our plugin, and in the second function, whenever the action function calls this special event for which the plugin is written, based on priority. This plugin is also called. But what is important is the final output of the call function. This output may be the input of other plugins with higher priorities. The order of the plugins is from small to large, and if several plugins are registered for a number, it is sorted by name in the second parameter. And it should be noted that in any case, if you did not want this state to go to other plugins and the last output is returned in the same plugin, and you can replace {:reply, :halt, new_state} with {:reply, new_state} . Subsequent plugins with higher priorities are not counted, and the loop ends here. Notice that a GenServer will be made based on each plugin name without a supervisor, which can be used for temporary memory in the case when the __using__ function is used as above, which results in the following option: use MishkaInstaller.Hook , module : __MODULE__ , behaviour : OnUserAfterLogin , event : :on_user_after_login , initial : [ ] The last two step to use the plugin you have to put it in your Application module so that whenever the server is turned off and on, the plugin is run again and if it is not registered, a copy of its support will be provided once in the database. children = [ %{ id : YOUR_PLUGIN_MODULE , start : { YOUR_PLUGIN_MODULE , :start_link , [ [ ] ] } } ] And add these config in your project like /config/config.exs config :mishka_installer , :basic , repo : YOUR_Repo , pubsub : YOUR_PUBSUB or nil , html_router : YOUR_WEBSITE_ROUTER_MODULE Module communication process of MishkaInstaller.Hook 1. call plugins + -- -- -- -- -- -- -- + | Application | + -- -- -- + -- -- -- - + | + -- -- -- v -- -- -- + | Supervisor | + -- -- -- + -- -- -- + | | + -- -- -- -- -- -- -- -- -- -- -- -- -- - + + -- -- -- -- -- -- v -- -- -- -- -- -- -- -- + | | | | | MishkaInstaller.PluginETS | | MishkaInstaller.PluginState | | | | | + -- -- -- -- -- -- -- - + -- -- -- -- -- - + + -- -- -- -- -- -- - + -- -- -- -- -- -- -- - + | | | | + -- - v -- -- -- -- -- -- -- -- -- -- -- -- -- - v -- -- - + | | | MishkaInstaller.Hook . call | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + 2. Register a plugin + -- -- -- -- -- -- -- + | Application | + -- -- -- + -- -- -- - + | + -- -- -- v -- -- -- + | Supervisor | + -- -- -- - + -- -- - + | | + -- -- -- -- -- -- -- -- -- -- -- -- -- - + + -- -- -- -- -- -- - v -- -- -- -- -- -- -- - + | | | | | MishkaInstaller.PluginETS | | MishkaInstaller.PluginState | | | | | + -- -- -- -- -- -- -- -- - ^ -- -- -- -- - + + -- -- -- -- -- -- - ^ -- -- -- -- -- -- -- - + | | | | + -- -- - + -- -- -- -- -- -- -- -- -- -- -- -- - + -- -- - + | | | MishkaInstaller.Hook . register | | | + -- -- -- -- -- -- -- -- -- - ^ -- -- -- -- -- -- -- -- - + | | + -- -- -- -- -- -- - + -- -- -- -- -- -- -- -- + | Developer &#39;s plugin GenServer | +-------------^----------------+ | | +-------------+----------------+ | | |Developer&#39; s plugin Application | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- +","ref":"MishkaInstaller.Hook.html","title":"MishkaInstaller.Hook","type":"module"},{"doc":"Your software will be able to call each of the active and registered plugins in the list in the order that they appear depending on the priority that the function assigns to each plugin, and it will do so with a particular event. The program generates a State and sends it to the first plugin in the list. This plugin, in turn, sends the desired output changes to the remaining plugins in the list, and this process is repeated all the way down to the plugin that is at the end of the list. It is important to note that you are free to make use of the available options in accordance with the logic of the component of your program that is responsible for loading the event you want. You can transmit a State to an unlimited number of plugins and perform various operations on it, but the output of the State will not be taken into consideration, and the starting State will be used as the one that determines the final output. You have the ability to include a portion of the State 's information in the private map. This flag ensures that just reading is open to the public, while authoring is obviously restricted in terms of the final product. At the time of registration, each plugin is assigned a priority; the lower this number, the higher the likelihood that this plugin will be called before others on the list; if it shares the same priority as multiple other plugins, the order in which it appears in the list will be determined by its name. Examples state = % MishkaInstaller.Reference.OnUserAfterLogin { conn : conn , endpoint : :html , user_info : user_info } # or load with private flag state = % TestEvent { user_info : %{ name : &quot;shahryar&quot; } , private : %{ acl : 0 , ip : &quot;127.0.1.1&quot; , endpoint : :admin } } MishkaInstaller.Hook . call ( event : &quot;on_user_after_login&quot; , state : state ) # or MishkaInstaller.Hook . call ( event : &quot;on_user_after_login&quot; , state : state , operation : :no_return ) # Example call in a controller def login ( conn , %{ &quot;user&quot; =&gt; %{ &quot;email&quot; =&gt; email , &quot;password&quot; =&gt; password } } = _params ) do # If your conditions are passed we call an event and pass it a struct of entries # which our developers need to create plugin with this information hook = MishkaInstaller.Hook . call ( event : &quot;on_user_after_login&quot; , state : state ) hook . conn |&gt; renew_session ( ) |&gt; put_session ( :user_id , user_info . id ) |&gt; put_flash ( :info , &quot;You entered to our world, well played.&quot; ) |&gt; redirect ( to : &quot;/home&quot; ) end","ref":"MishkaInstaller.Hook.html#call/1","title":"MishkaInstaller.Hook.call/1","type":"function"},{"doc":"This function will delete the specified plugin from the State that you are contemplating, but there will be no change to the database due to this action. It is important to remember that stopping a batch based on a particular occurrence is also possible. Examples MishkaInstaller.Hook . delete ( module : &quot;ensure_event_plugin&quot; ) # or MishkaInstaller.Hook . delete ( event : &quot;on_user_after_login&quot; )","ref":"MishkaInstaller.Hook.html#delete/1","title":"MishkaInstaller.Hook.delete/1","type":"function"},{"doc":"The operation performed in this function is the same as ensure_event?/1 , except that the output is a pattern with a special message. Examples test_plug = % MishkaInstaller.PluginState { name : &quot;MishkaInstaller.Hook&quot; , event : &quot;event_one&quot; , depend_type : :hard , depends : [ &quot;MishkaInstaller.PluginState&quot; ] } MishkaInstaller.Hook . ensure_event ( test_plug , :debug )","ref":"MishkaInstaller.Hook.html#ensure_event/2","title":"MishkaInstaller.Hook.ensure_event/2","type":"function"},{"doc":"You will have the opportunity to select the type of dependency, which can either be :soft or :hard , when you are in the process of registering each plugin. It is not necessary to check related plugins if this item is configured to use the first available option, and a plugin can be installed in the system on its own accord if this option is selected. If the second choice for the desired plugin is chosen, which is hard , then this method will be of assistance to you. It will verify each of the plugins listed in the dependent parameter, and if there are no issues, it will return true . If there are issues, however, it will return false . Examples test_plug = % MishkaInstaller.PluginState { name : &quot;MishkaInstaller.Hook&quot; , event : &quot;event_one&quot; , depend_type : :hard , depends : [ &quot;MishkaInstaller.PluginState&quot; ] } MishkaInstaller.Hook . ensure_event? ( test_plug )","ref":"MishkaInstaller.Hook.html#ensure_event?/1","title":"MishkaInstaller.Hook.ensure_event?/1","type":"function"},{"doc":"Registering a plugin is the first step in modularizing and event-oriented programming for your project. You should be aware, prior to registering a custom plugin to the project and activating it in a particular section, that the plugin is designed by a programmer and is required to adhere to a series of fundamental structures before it can be used. Each plugin must meet the following conditions when registering: Because the process of utilizing a plugin is dependent on beginning GenServer by the name of that plugin, you need to think of it as a GenServer and begin using it. If you do not wish to handle this process manually, the __using__ module of the Hook package has already prepared it for you; all you need to do is call it. The aforementioned explanation can be found in its entirety in the code snippet. The definition of each plugin is determined by a certain behavior carried out by a module. You need to have some fundamental instances of this behavior, in addition to the requirements set forth by the plugin's developer. Some fundamental behaviors are as follows: initial call stop delete restart start For more clarity, you can see MishkaInstaller.Reference.OnUserLoginFailure behavior. All plugins are stored in ETS. All plugins are stored in the database. All plugins are stored in one supervisor and another GenServer . In order to register a plugin, you need to call it in the initial function of the module in which you used the MishkaInstaller.Hook directive and bind it with the use directive. Take, for instance: use MishkaInstaller.Hook , module : __MODULE__ , behaviour : OnUserAfterLogin , event : :on_user_after_login , initial : [ ] @spec initial ( list ( ) ) :: { :ok , OnUserAfterLogin . ref ( ) , list ( ) } def initial ( args ) do event = % PluginState { name : &quot;MishkaUser.SuccessLogin&quot; , event : Atom . to_string ( @ref ) , priority : 1 } Hook . register ( event : event ) { :ok , @ref , args } end After being added to the MishkaInstaller.PluginState module struct, each plug-in is required to be registered in the system, as demonstrated by the preceding line of code. It is important to know that each plugin in your project can be registered in one of two different ways. By diagnosing problems and ensuring that the requested plugin is operational. By requiring the test stages to be completed or by ignoring the requirements of the plug-in itself. Examples event = % PluginState { name : &quot;MishkaUser.SuccessLogin&quot; , event : Atom . to_string ( @ref ) , priority : 1 } MishkaInstaller.Hook . register ( event : event ) # or MishkaInstaller.Hook . register ( event : event , depends : :force )","ref":"MishkaInstaller.Hook.html#register/1","title":"MishkaInstaller.Hook.register/1","type":"function"},{"doc":"Based on the function restart/1 , restart all installed plugins. Examples MishkaInstaller.Hook . restart ( )","ref":"MishkaInstaller.Hook.html#restart/0","title":"MishkaInstaller.Hook.restart/0","type":"function"},{"doc":"The only difference between this method and the start/1 function is that this function deletes from RAM any states that are associated with the plugin that you want to use. Examples MishkaInstaller.Hook . restart ( module : &quot;ensure_event_plugin&quot; ) # or MishkaInstaller.Hook . restart ( module : &quot;ensure_event_plugin&quot; , depends : :force ) # or MishkaInstaller.Hook . restart ( event : &quot;on_user_after_login&quot; ) # or MishkaInstaller.Hook . restart ( event : &quot;on_user_after_login&quot; , depends : :force )","ref":"MishkaInstaller.Hook.html#restart/1","title":"MishkaInstaller.Hook.restart/1","type":"function"},{"doc":"You are able to activate all the plugins that have been installed by using this feature. It is important to point out that it is possible to activate numerous plugins at the same time as a single plugin or even a batch based on a particular event. This can be done in several different ways. Much like the register/1 function, this function has two modes, which can be altered by looking at the needs of a plugin and the forced mode, respectively. Note: When running in debug mode, the referred-to plugin in the project must be set to Application.load/1 , and Application.unload/1 cannot be started. Note: If your plugin has other dependencies, all of them must be activated before restarting. For more information, see ensure_event?/1 and ensure_event/2 functions. Examples MishkaInstaller.Hook . start ( module : &quot;ensure_event_plugin&quot; ) # or MishkaInstaller.Hook . start ( module : &quot;ensure_event_plugin&quot; , depends : :force ) # or MishkaInstaller.Hook . start ( event : &quot;on_user_after_login&quot; ) # or MishkaInstaller.Hook . start ( event : &quot;on_user_after_login&quot; , depends : :force )","ref":"MishkaInstaller.Hook.html#start/1","title":"MishkaInstaller.Hook.start/1","type":"function"},{"doc":"This function will stop the specified plugin from the State that you are contemplating, but there will be no change to the database due to this action. It is important to remember that stopping a batch based on a particular occurrence is also possible. Examples MishkaInstaller.Hook . stop ( module : &quot;ensure_event_plugin&quot; ) # or MishkaInstaller.Hook . stop ( event : &quot;on_user_after_login&quot; )","ref":"MishkaInstaller.Hook.html#stop/1","title":"MishkaInstaller.Hook.stop/1","type":"function"},{"doc":"This function is very similar to the delete/1 command; however, in addition to removing the plugin from the system, it also removes the plugin from the database. Examples MishkaInstaller.Hook . unregister ( module : &quot;ensure_event_plugin&quot; ) # or MishkaInstaller.Hook . unregister ( event : &quot;on_user_after_login&quot; )","ref":"MishkaInstaller.Hook.html#unregister/1","title":"MishkaInstaller.Hook.unregister/1","type":"function"},{"doc":"This type can be used when you want to introduce an event","ref":"MishkaInstaller.Hook.html#t:event/0","title":"MishkaInstaller.Hook.event/0","type":"type"},{"doc":"This type can be used when you want to introduce an plugin","ref":"MishkaInstaller.Hook.html#t:plugin/0","title":"MishkaInstaller.Hook.plugin/0","type":"type"},{"doc":"This module serializes how to get and install a library and add it to your system. Based on the structure of MishkaInstaller , this module should not be called independently. The reason for the indirect call is to make the queue and also to run the processes in the background. For this purpose, two workers have been created for this module, which can handle the update operation and add a library. Below you can see the graph of connecting this module to another module. + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | | &lt;- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | MishkaInstaller.Installer.DepHandler | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- - + -- -- -- + | | | | + -- -- -- -- -- -- -- -- -- - + -- -- -- -- -- -- -- -- - ^ - + | | | | | MishkaInstaller.DepCompileJob | | | | &lt;- -- -- -- -- -- + | | | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | | | | | | | | | | MishkaInstaller.DepUpdateJob | | | + -- -- -- -- - + | | | | | | | + - ^ -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | + -- -- -- -- -- -- -- -- -- - v -- -- -- -- -- -- -- -- -- -- -- -- -- - + | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | | | | | | | | | | MishkaInstaller.Installer.DepChangesProtector + - + | MishkaInstaller.Installer.Live.DepGetter | | | | | | | | | + -- -- -- -- -- -- -- -- -- -- - + -- -- -- -- -- -- -- -- -- -- -- -- - + + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | + -- -- -- -- -- -- -- -- -- - v -- -- -- -- -- -- -- -- -- -- -- - + | | | MishkaInstaller.Installer.RunTimeSourcing | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + As you can see in the graph above, most of the requests, except the update request, pass through the path of the MishkaInstaller.DepCompileJob module and call some functions of the MishkaInstaller.Installer.DepHandler module. After completing the operation process, this module finally serializes the queued requests and broadcasts the output by means of Pubsub . Warning : Direct use of this module causes conflict in long operations and causes you to receive an error, or the system is completely down. Warning : The update operation is connected to the worker of the MishkaInstaller.DepUpdateJob module. Warning : this section should be limited to the super admin user because it is directly related to the core of the system. Warning : User should always be notified to get backup. Warning : Do not send timeout request to Genserver of this module. Warning : This module must be supervised in the Application.ex file and loaded at runtime. Warning : this module has a direct relationship with the extension.json file, so it checks this file every few seconds and fixes it if it is not created or has a problem. Warning : If you put Pubsub in your configuration settings and the value is not nil, this module will automatically send a timeout several times until your Pubsub process goes live. Warning : at the time of starting Genserver, this module also starts MishkaInstaller.DepUpdateJob.ets/0 runtime database. Warning : All possible errors are stored in the database introduced in the configuration, and you can access it with the functions of the MishkaInstaller.Activity module.","ref":"MishkaInstaller.Installer.DepChangesProtector.html","title":"MishkaInstaller.Installer.DepChangesProtector","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MishkaInstaller.Installer.DepChangesProtector.html#child_spec/1","title":"MishkaInstaller.Installer.DepChangesProtector.child_spec/1","type":"function"},{"doc":"This function is actually an action function and aggregator. You call this GenServer.cast function with three inputs {:deps, app, type} , which executes with a very small timeout. Warning: It is highly recommended not to call this function directly and use the worker ( MishkaInstaller.DepCompileJob ) to compile. Finally, this function calls the MishkaInstaller.Installer.RunTimeSourcing.do_deps_compile/2 function with the help of Task.Supervisor.async_nolink/2 . It is worth mentioning that you can view and monitor the output by subscribing to this module. Examples MishkaInstaller.Installer.DepChangesProtector . deps ( app_name , output_type )","ref":"MishkaInstaller.Installer.DepChangesProtector.html#deps/2","title":"MishkaInstaller.Installer.DepChangesProtector.deps/2","type":"function"},{"doc":"","ref":"MishkaInstaller.Installer.DepChangesProtector.html#get/0","title":"MishkaInstaller.Installer.DepChangesProtector.get/0","type":"function"},{"doc":"This function checks if any process is running or not. if true means no job is being done, if false means there is a job is being done. Examples MishkaInstaller.Installer.DepChangesProtector . is_dependency_compiling? ( )","ref":"MishkaInstaller.Installer.DepChangesProtector.html#is_dependency_compiling?/0","title":"MishkaInstaller.Installer.DepChangesProtector.is_dependency_compiling?/0","type":"function"},{"doc":"This function helps the programmer to join the channel of this module( MishkaInstaller.Installer.DepChangesProtector ) and receive the output as a broadcast in the form of {status, :dep_changes_protector, answer, app} . It uses Phoenix.PubSub.subscribe/2 . Examples # Subscribe to `MishkaInstaller.Installer.DepChangesProtector` module MishkaInstaller.Installer.DepChangesProtector . subscribe ( ) # Getting the answer as Pubsub for examples in LiveView @impl Phoenix.LiveView def handle_info ( { status , :dep_changes_protector , answer , app } , socket ) do { :noreply , socket } end","ref":"MishkaInstaller.Installer.DepChangesProtector.html#subscribe/0","title":"MishkaInstaller.Installer.DepChangesProtector.subscribe/0","type":"function"},{"doc":"A module aggregates several operational functions to simplify the integration of all activities, including adding - removing, and updating a library in the project. For this purpose, you can use this module directly in your program or just call some helper functions. It should be noted that this module, like the MishkaInstaller.Installer.RunTimeSourcing module, has a primary function that performs all the mentioned operations based on the request type ( run/2 ). Also, to perform some activities before applying any changes, the database and extensions.json file of your project will be rechecked. For example, these are output from Json file and this module struct [ %{ app : :mishka_installer , version : &quot;0.0.2&quot; , type : :git , # :hex, if user upload elixir libraries (path), we should keep them in a temporary folder, and Docker should make it valume url : &quot;https://github.com/mishka-group/mishka_installer&quot; , # if it is hex: https://hex.pm/packages/mishka_installer git_tag : &quot;0.0.2&quot; , # we consider it when it is a git, and if does not exist we get master, custom_command : &quot;ecto.migrate&quot; , # you can write nil or you task file like ecto.migrate dependency_type : :none , # :force_update, When you use this, the RunTime sourcing check what dependencies you use # in your program have a higher version compared to the old source. it just notice admin there is a update, # it does not force the source to be updated. dependencies : [ # this part let mishka_installer to know can update or not dependencies of a app, we should consider a backup file %{ app : :mishka_developer_tools , max : &quot;0.0.2&quot; , min : &quot;0.0.1&quot; } , %{ app : :mishka_social , max : &quot;0.0.2&quot; , min : &quot;0.0.1&quot; } ] } ] OR % MishkaInstaller.Installer.DepHandler { app : &quot;mishka_social&quot; , version : &quot;0.0.2 &quot; , type : &quot;hex&quot; , url : &quot;https://hex.pm/packages/mishka_social&quot; , git_tag : nil , custom_command : nil , dependency_type : &quot;force_update&quot; , dependencies : [ %{ app : :phoenix , min : &quot;1.6&quot; } , %{ app : :phoenix_live_view , max : &quot;0.17.7&quot; , min : &quot;0.17.7&quot; } , %{ app : :ueberauth , max : &quot;0.17.7&quot; , min : &quot;0.17.7&quot; } , %{ app : :ueberauth_github , min : &quot;0.8.1&quot; } , %{ app : :ueberauth_google , min : &quot;0.10.1&quot; } , ] } Below you can see the graph of connecting this module to another module. + -- -- -- -- -- -- -- -- -- -- -- -- -- -- + + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | | | | MishkaInstaller.Dependency | | MishkaInstaller.Installer.MixCreator | | &lt;- -- + + -- -- &gt; | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | | | | | | MishkaInstaller.Installer.RunTimeSourcing | | | | | | | + -- - ^ -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + - + -- - + | | | | | MishkaInstaller.Installer.DepHandler + -- -- + | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- ^ -- -- -- -- - + | | + -- -- -- -- -- -- -- -- -- -- -- -- + -- -- -- -- -- -- -- - + | | | MishkaInstaller.Installer.Live.DepGetter | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- +","ref":"MishkaInstaller.Installer.DepHandler.html","title":"MishkaInstaller.Installer.DepHandler","type":"module"},{"doc":"This function helps developers to decide what they should do when an app is going to be updated. For example, each of the extensions maybe has states or necessary jobs; hence they can register their app for on_change_dependency event. Examples old_ueberauth = % DepHandler { app : &quot;ueberauth&quot; , version : &quot;0.6.3&quot; , type : &quot;hex&quot; , url : &quot;https://hex.pm/packages/ueberauth&quot; , git_tag : nil , custom_command : nil , dependency_type : &quot;force_update&quot; , dependencies : [ %{ app : :plug , min : &quot;1.5.0&quot; } ] } MishkaInstaller.Installer.DepHandler . add_new_app ( old_ueberauth )","ref":"MishkaInstaller.Installer.DepHandler.html#add_new_app/1","title":"MishkaInstaller.Installer.DepHandler.add_new_app/1","type":"function"},{"doc":"This function mixes your current list of dependencies with your added-dependencies from extensions.json . This function calls 1 other function including: mix_read_from_json/0 Examples list_of_deps = [ { :finch , &quot;~&gt; 0.12.0&quot; } , { :ex_doc , &quot;&gt;= 0.0.0&quot; , only : :dev , runtime : false } , { :ueberauth , git : &quot;url&quot; , tag : &quot;0.6.3&quot; } ] MishkaInstaller.Installer.DepHandler . append_mix ( list_of_deps )","ref":"MishkaInstaller.Installer.DepHandler.html#append_mix/1","title":"MishkaInstaller.Installer.DepHandler.append_mix/1","type":"function"},{"doc":"With this function, you can check and create extensions.json and its path. Examples MishkaInstaller.Installer.DepHandler . check_or_create_deps_json ( )","ref":"MishkaInstaller.Installer.DepHandler.html#check_or_create_deps_json/1","title":"MishkaInstaller.Installer.DepHandler.check_or_create_deps_json/1","type":"function"},{"doc":"A function to compare dependencies between extensions.json and Application.loaded_applications/0 ; if an app exists, it returns. This function calls 3 other functions including: check_or_create_deps_json/0 Application.loaded_applications/0 read_dep_json/1 Examples MishkaInstaller.Installer.DepHandler . compare_dependencies_with_json ( )","ref":"MishkaInstaller.Installer.DepHandler.html#compare_dependencies_with_json/1","title":"MishkaInstaller.Installer.DepHandler.compare_dependencies_with_json/1","type":"function"},{"doc":"This function compare installed app based on their files in _build and deps directory. This function calls 4 other functions including: MishkaInstaller.Installer.RunTimeSourcing.read_app/2 MishkaInstaller.Installer.RunTimeSourcing.consult_app_file/1 compare_version_with_installed_app/2 File.dir?/1 Examples MishkaInstaller.Installer.DepHandler . compare_installed_deps_with_app_file ( &quot;app_name&quot; )","ref":"MishkaInstaller.Installer.DepHandler.html#compare_installed_deps_with_app_file/1","title":"MishkaInstaller.Installer.DepHandler.compare_installed_deps_with_app_file/1","type":"function"},{"doc":"This function works like compare_dependencies_with_json/0 , but there is a difference which is in this part of the code, we compare the installed app with sup-dependencies based on min and max versions that are allowed. Examples MishkaInstaller.Installer.DepHandler . compare_sub_dependencies_with_json ( ) Reference How to improve sort of maps in a list which have duplicate key ( https://elixirforum.com/t/47486 )","ref":"MishkaInstaller.Installer.DepHandler.html#compare_sub_dependencies_with_json/1","title":"MishkaInstaller.Installer.DepHandler.compare_sub_dependencies_with_json/1","type":"function"},{"doc":"This function helps you to compare an app version with its installed version, it returns true or false . Based on Application.spec/2 Examples MishkaInstaller.Installer.DepHandler . compare_version_with_installed_app ( app , version )","ref":"MishkaInstaller.Installer.DepHandler.html#compare_version_with_installed_app/2","title":"MishkaInstaller.Installer.DepHandler.compare_version_with_installed_app/2","type":"function"},{"doc":"This function creates extensions.json as a json file. Examples MishkaInstaller.Installer.DepHandler . create_deps_json_file ( project_path )","ref":"MishkaInstaller.Installer.DepHandler.html#create_deps_json_file/1","title":"MishkaInstaller.Installer.DepHandler.create_deps_json_file/1","type":"function"},{"doc":"For more information, please read create_mix_file_and_start_compile/2 , but consider this function just re-creates mix.exs file and does not compile an app. This function is based on the Sourceror library. Examples MishkaInstaller.Installer.DepHandler . create_mix_file ( )","ref":"MishkaInstaller.Installer.DepHandler.html#create_mix_file/0","title":"MishkaInstaller.Installer.DepHandler.create_mix_file/0","type":"function"},{"doc":"This function provides an option to edit and start compiling from a mix.exs file. It should be considered to use this facility as a helper because it might be deleted on the next version from our primary process; create_mix_file_and_start_compile/2 is kept to let developers use this based on their problems. You must put two entries, the first one is the app name, and the second one is the type of compiling, which can be shown in a terminal as stream outputs or sent with Pubsub and Port . This function is based on the Sourceror library, and the types we discussed include :cmd and :port . This function calls 3 other functions including: create_deps_json_file/1 MishkaInstaller.Installer.MixCreator.backup_mix/1 MishkaInstaller.Installer.DepChangesProtector.deps/2 Examples MishkaInstaller.Installer.DepHandler . create_mix_file_and_start_compile ( app , type )","ref":"MishkaInstaller.Installer.DepHandler.html#create_mix_file_and_start_compile/2","title":"MishkaInstaller.Installer.DepHandler.create_mix_file_and_start_compile/2","type":"function"},{"doc":"This functions returns extensions.json file path based on :project_path . Examples MishkaInstaller.Installer.DepHandler . extensions_json_path ( )","ref":"MishkaInstaller.Installer.DepHandler.html#extensions_json_path/0","title":"MishkaInstaller.Installer.DepHandler.extensions_json_path/0","type":"function"},{"doc":"It returns dependencies as a list of maps from mix.exs Examples MishkaInstaller.Installer.DepHandler . get_deps_from_mix ( MishkaInstaller.MixProject )","ref":"MishkaInstaller.Installer.DepHandler.html#get_deps_from_mix/1","title":"MishkaInstaller.Installer.DepHandler.get_deps_from_mix/1","type":"function"},{"doc":"It returns dependencies as a list of maps from mix.lock , based on Mix.Dep.Lock.read Examples MishkaInstaller.Installer.DepHandler . get_deps_from_mix_lock ( )","ref":"MishkaInstaller.Installer.DepHandler.html#get_deps_from_mix_lock/0","title":"MishkaInstaller.Installer.DepHandler.get_deps_from_mix_lock/0","type":"function"},{"doc":"This function uses read_dep_json/0 to read extensions.json file and returns list of dependencies-map. Examples MishkaInstaller.Installer.DepHandler . mix_read_from_json ( )","ref":"MishkaInstaller.Installer.DepHandler.html#mix_read_from_json/0","title":"MishkaInstaller.Installer.DepHandler.mix_read_from_json/0","type":"function"},{"doc":"With this function help you can move built app file to _build folder. This function calls 3 other functions including: MishkaInstaller.Installer.RunTimeSourcing.do_runtime/2 MishkaInstaller.Installer.RunTimeSourcing.get_build_path/0 File.cp_r/3 Examples MishkaInstaller.Installer.DepHandler . move_and_replace_compiled_app_build ( app_list )","ref":"MishkaInstaller.Installer.DepHandler.html#move_and_replace_compiled_app_build/1","title":"MishkaInstaller.Installer.DepHandler.move_and_replace_compiled_app_build/1","type":"function"},{"doc":"This Function is for interacting with the external extensions.json file to load added-libraries. Examples MishkaInstaller.Installer.DepHandler . read_dep_json ( ) # or MishkaInstaller.Installer.DepHandler . mix_read_from_json ( JSON_PATH )","ref":"MishkaInstaller.Installer.DepHandler.html#read_dep_json/1","title":"MishkaInstaller.Installer.DepHandler.read_dep_json/1","type":"function"},{"doc":"The run/2 function is actually the function of the installer and assembler of all the modules that this module is connected to. This function has two inputs that you can see in the examples below. The first input is an atom, which specifies how to install a library in the system. Depending on the installation method, the second entry can be the dependency information requested for the installation. Examples Application . spec ( :timex , :vsn ) MishkaInstaller.Installer.DepHandler . run ( :hex , &quot;faker&quot; ) app = %{ url : &quot;https://github.com/bitwalker/timex&quot; , tag : &quot;3.7.5&quot; } MishkaInstaller.Installer.DepHandler . run ( :git , app ) app = %{ url : &quot;https://github.com/bitwalker/timex&quot; , tag : &quot;3.7.6&quot; } MishkaInstaller.Installer.DepHandler . run ( :git , app ) app = %{ url : &quot;https://github.com/bitwalker/timex&quot; , tag : &quot;3.7.8&quot; } MishkaInstaller.Installer.DepHandler . run ( :git , app ) app = %{ url : &quot;https://github.com/elixirs/faker&quot; , tag : &quot;v0.17.0&quot; } MishkaInstaller.Installer.DepHandler . run ( :git , app ) app = %{ url : &quot;https://github.com/martinsvalin/html_entities&quot; , tag : &quot;v0.5.1&quot; } MishkaInstaller.Installer.DepHandler . run ( :git , app ) app = %{ url : &quot;https://github.com/beatrichartz/csv&quot; , tag : &quot;v2.3.0&quot; } MishkaInstaller.Installer.DepHandler . run ( :git , app ) MishkaInstaller.Installer.DepHandler . run ( :upload , [ &quot;../mishka_installer/deployment/extensions/timex-3.7.8.zip&quot; ] ) Reference Fix phoenix reload issue when a dependency is compiled ( https://github.com/phoenixframework/phoenix/issues/4278 ) Phoenix.CodeReloader.reload/1 ( https://hexdocs.pm/phoenix/Phoenix.CodeReloader.html#reload/1 )","ref":"MishkaInstaller.Installer.DepHandler.html#run/3","title":"MishkaInstaller.Installer.DepHandler.run/3","type":"function"},{"doc":"This type can be used when you want to introduce an app to install","ref":"MishkaInstaller.Installer.DepHandler.html#t:app_info/0","title":"MishkaInstaller.Installer.DepHandler.app_info/0","type":"type"},{"doc":"This is delegate of Application.loaded_applications/0 output","ref":"MishkaInstaller.Installer.DepHandler.html#t:installed_apps/0","title":"MishkaInstaller.Installer.DepHandler.installed_apps/0","type":"type"},{"doc":"This type can be used when you want to introduce method of install a dependency","ref":"MishkaInstaller.Installer.DepHandler.html#t:run/0","title":"MishkaInstaller.Installer.DepHandler.run/0","type":"type"},{"doc":"This type can be used when you want to put your data in this module struct","ref":"MishkaInstaller.Installer.DepHandler.html#t:t/0","title":"MishkaInstaller.Installer.DepHandler.t/0","type":"type"},{"doc":"Allows you to work with installed extensions in a simple and efficient manner. Some important tools and removal / installation facilities are accessible for usage. It's not necessary to install this module; you may do it in a matter of seconds. Using this dashboard will need the usage of Phoenix LiveView , as it was built entirely using this library. Bootstrap is used to construct the HTML components, but if you don't have it, you'll need to add the CSS yourself. Real-time services are available in this section. A different LiveView file can also be used, as can calling it directly from the router. It is through this layer that the Port and Phoenix Pubsub modules are linked to keep tabs on the installation. Note: This dashboard is currently modest, but greater management tools will be provided in the future, therefore we recommend that you utilize it now. Note: For this reason, make important to set up authentication and authorization procedures and provide it access to your superuser before using this dashboard. Below you can see the graph of connecting this module to another module. + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | MishkaInstaller.Installer.Live.DepGetter + -- -- -- - + | | | + -- -- -- -- -- -- -- -- -- + -- -- -- -- -- -- -- -- -- -- - + | | | | | | | + -- -- -- -- -- -- -- -- v -- -- -- -- -- -- -- -- -- - + | | | | | MishkaInstaller.Installer.DepHandler | | | | | + -- -- -- -- -- -- -- -- + -- -- -- -- -- -- -- -- -- - + | | | | | | | + -- -- -- -- -- -- -- -- -- v -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | MishkaInstaller.Installer.DepChangesProtector | | | | | + -- -- - + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | | | | | | | + -- -- -- -- -- -- -- -- -- -- v - + | | | | | MishkaInstaller.Hook | | | | | + -- -- -- -- - + -- -- -- -- -- -- + | | | | | + -- -- -- -- -- -- -- -- -- -- v -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | MishkaInstaller.Reference.OnChangeDependency | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | + -- -- -- -- -- -- -- -- + -- -- -- -- -- -- -- -- -- -- -- -- - + | | + -- -- -- -- -- -- -- -- -- -- v -- -- -- -- -- -- -- -- -- -- + | | | | | MishkaInstaller.Installer.RunTimeSourcing | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | MishkaInstaller.DepCompileJob + -- -- -&gt; + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- v - + | MishkaInstaller.DepUpdateJob | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- +","ref":"MishkaInstaller.Installer.Live.DepGetter.html","title":"MishkaInstaller.Installer.Live.DepGetter","type":"module"},{"doc":"","ref":"MishkaInstaller.Installer.Live.DepGetter.html#error_to_string/1","title":"MishkaInstaller.Installer.Live.DepGetter.error_to_string/1","type":"function"},{"doc":"In version 0.0.2, the MishkaInstaller library was used to download a dependency from the project's own mix.exs file, so this module was written to edit this file. In fact, this module uses the Sourceror library to change the mentioned mix.exs file (with AST ). Another use of this module is reading information from the programmer's Git or custom link. Warning: in the next versions of MishkaInstaller, instead of mix.exs , the client project will be downloaded directly from Git or hex.pm site. If this update is executed, the original project will not be changed. This module is not going to be deleted in new versions.","ref":"MishkaInstaller.Installer.MixCreator.html","title":"MishkaInstaller.Installer.MixCreator","type":"module"},{"doc":"With the help of this function, you can make a backup copy of mix.exs and mix.lock of your project and keep it in the deployment/extensions path. If this function is used with one input, it targets the mix.exs file, and if the second input is :lock atom, it targets the mix.lock file to keep a backup copy. With the help of this function, you can make a backup copy of mix.exs and mix.lock of your project and keep it in the deployment/extensions path. If this function is used with one input, it targets the mix.exs file, and if the second input is :lock atom, it targets the mix.lock file to keep a backup copy. Examples MishkaInstaller.Installer.MixCreator . backup_mix ( &quot;mix.exs&quot; ) MishkaInstaller.Installer.MixCreator . backup_mix ( &quot;mix.lock&quot; , :lock )","ref":"MishkaInstaller.Installer.MixCreator.html#backup_mix/1","title":"MishkaInstaller.Installer.MixCreator.backup_mix/1","type":"function"},{"doc":"Read backup_mix/1 description.","ref":"MishkaInstaller.Installer.MixCreator.html#backup_mix/2","title":"MishkaInstaller.Installer.MixCreator.backup_mix/2","type":"function"},{"doc":"This function receives a list of libraries stored in the extensions.json file along with the mix.exs path of the file that needs to be changed, and after that, it changes the deps function in mix.exs and overwrites it with the new libraries. Examples mix_path = MishkaInstaller . get_config ( :mix ) MixCreator . create_mix ( mix_path . project [ :deps ] , &quot;mix_path&quot; ) As you see, we pass the current dependencies to let this function merge it with extensions.json","ref":"MishkaInstaller.Installer.MixCreator.html#create_mix/2","title":"MishkaInstaller.Installer.MixCreator.create_mix/2","type":"function"},{"doc":"This function is also the same as the backup_mix/1 function, with the difference that it returns the backed-up version to the project path. Both functions use the File.copy/2 function just to improve the naming and also to warn the programmer that it has been replaced in this file. Examples MishkaInstaller.Installer.MixCreator . restore_mix ( &quot;mix.exs&quot; ) MishkaInstaller.Installer.MixCreator . restore_mix ( &quot;mix.lock&quot; , :lock )","ref":"MishkaInstaller.Installer.MixCreator.html#restore_mix/1","title":"MishkaInstaller.Installer.MixCreator.restore_mix/1","type":"function"},{"doc":"Read restore_mix/1 description.","ref":"MishkaInstaller.Installer.MixCreator.html#restore_mix/2","title":"MishkaInstaller.Installer.MixCreator.restore_mix/2","type":"function"},{"doc":"Using this module, you can independently add a downloaded-library while your system is running, with minimal dependencies. The important thing to note is that you are actually adding a complete dependency and a complete Elixir project which is compiled to the system, and this is not Hot Coding. At the time of this section's development, we have been very aware that with the least dependence and only with the Erlang and Elixir functions do all the process. We covered the whole process, but without informing different sectors and being able to notify the installation, removing, and updating process, it would be incomplete. We couldn't leave the programmers. Hence, the Phoenix Pubsub library can be an excellent option to notice processes are subscribed to in the MishkaInstaller channel. The purpose of this section is divided into two categories as follows: View in the terminal Send Ported Output by Pubsub This module requires the import_path as a variable system, which is your project's path. Below you can see the graph of connecting this module to another module. + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | MishkaInstaller.Installer.DepHandler + -- -- -- -- -- -- -- -- -- -- + | | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + + -- -- -- -- -- -- -- -- - v -- -- -- -- -- -- -- -- -- -- -- -- - + | | | | | MishkaInstaller.Installer.Live.DepGetter + -- -- -- -&gt; MishkaInstaller.Installer.RunTimeSourcing | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - + + -- -- -- -- -- -- -- -- -- ^ -- -- -- -- -- -- -- -- -- -- -- -- + | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | | | | MishkaInstaller.Installer.DepChangesProtector | | | + -- -- -- -- -- -- -- -- -- -- - + | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + Warning: This module is independent and surrounded by operational functions to create a custom system by developers themselves. Suppose you want to have an action function that makes an exemplary process by managing errors and the download queue. In that case, it is best to use two MishkaInstaller.Installer.DepHandler and MishkaInstaller.Installer.Live.DepGetter modules. Warning: In this version, we use the project mix.exs so that this file does not change, and the new library is not added to it; it is impossible to use these functions. For your convenience, we added a module named mix creator as MishkaInstaller.Installer.MixCreator module. If you don't want to change mix.exs and download a dependency, you need to prepper the library file directly and compile it. Warning: Being limited to mix.exs will be deleted in the future.","ref":"MishkaInstaller.Installer.RunTimeSourcing.html","title":"MishkaInstaller.Installer.RunTimeSourcing","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#child_spec/1","title":"MishkaInstaller.Installer.RunTimeSourcing.child_spec/1","type":"function"},{"doc":"This function helps you compare the installed libraries and the ones you want to install and displays the ones not installed in a list. The first entry is the installed apps, which can be left blank. it is loaded from Application.loaded_applications/0 . Examples MishkaInstaller.Installer.RunTimeSourcing . compare_dependencies ( [ &quot;the_app_does_not_exist&quot; , &quot;compiler&quot; ] )","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#compare_dependencies/2","title":"MishkaInstaller.Installer.RunTimeSourcing.compare_dependencies/2","type":"function"},{"doc":"This function converts loaded .app file as elixir type like list and tuple References: https://elixirforum.com/t/how-to-get-vsn-from-app-file/48132/2 https://github.com/elixir-lang/elixir/blob/main/lib/mix/lib/mix/tasks/compile.all.ex#L153-L154","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#consult_app_file/1","title":"MishkaInstaller.Installer.RunTimeSourcing.consult_app_file/1","type":"function"},{"doc":"This aggregator function is an action function to download and compile requested dependencies. You can decide what your default output is. It should be noted that this part of the project supports Terminal output with System.cmd/2 function and sending Pubsub with Port.open/2 module. Warning: the routing of this function may change in future versions. Please check it in each version if you use this function directly. Please consider after each operation; the directory reference gets back to the project path. Examples MishkaInstaller.Installer.RunTimeSourcing . do_deps_compile ( &quot;test_app&quot; , :cmd ) MishkaInstaller.Installer.RunTimeSourcing . do_deps_compile ( &quot;test_app&quot; , :port )","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#do_deps_compile/2","title":"MishkaInstaller.Installer.RunTimeSourcing.do_deps_compile/2","type":"function"},{"doc":"This function is made in three different situations that you can load according to your own needs. The overall purpose of this function with different patterns is to add - update and delete a library on your Elixir project without the need for Downtime. The first pattern is :add . This function adds a library that is neither already installed nor loaded on your project. The overall activity of this function can be divided into several parts: Routing of compiled sub-libraries (requested library dependencies) Check compiled dependencies with installed-dependencies Introducing and addressing dependencies (in terms of files) Introducing and starting dependencies on the system As we have mentioned in option 4 when a state dependency is started, it also starts working; now, these items can be called directly by the programmer or placed in the Application.ex of the plugin itself as a Genserver . The first entry is the dependency name. This name must be exactly the name mentioned in the mix.exs file of the requested dependency. For this purpose, the type of the library name must be an atom type and the second entry is :add . Examples MishkaInstaller.Installer.RunTimeSourcing . do_runtime ( :mishka_developer_tools , :add ) # Or MishkaInstaller.Installer.RunTimeSourcing . do_runtime ( :mishka_social , :add ) This function calls 6 other functions including: get_build_path/0 File.ls!/1 Enum.reject/2 compare_dependencies/2 prepend_compiled_apps/2 application_ensure/2 The second pattern is :force_update . This pattern is similar to :add , except that you no longer check the installed dependencies with the compiled ones. This pattern is mostly used for updates or when you are sure everything is already in place. Examples MishkaInstaller.Installer.RunTimeSourcing . do_runtime ( :mishka_developer_tools , :force_update ) # Or MishkaInstaller.Installer.RunTimeSourcing . do_runtime ( :mishka_social , :force_update ) This function calls 5 other functions including: get_build_path/0 File.ls!/1 Enum.reject/2 prepend_compiled_apps/2 application_ensure/2 The third pattern is :uninstall . This function stops an already installed library and removes it from the list of installed libraries(unload an app). After deleting by the Application module functions, the compiled directory of the requested library is also deleted. Examples MishkaInstaller.Installer.RunTimeSourcing . do_runtime ( :mishka_developer_tools , :uninstall ) # Or MishkaInstaller.Installer.RunTimeSourcing . do_runtime ( :mishka_social , :uninstall ) This function calls 5 other functions including: File.ls!/1 Application.stop/1 Application.unload/1 delete_app_dir/1 get_build_path/1","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#do_runtime/2","title":"MishkaInstaller.Installer.RunTimeSourcing.do_runtime/2","type":"function"},{"doc":"It displays the build directory path based on MishkaInstaller.get_config/1 . Hence you should bind :project_path on runtime or before running the CMS in your config. The first entry is the Environment status, which can be left blank. it is loaded from Mix.env/0 . Examples MishkaInstaller.Installer.RunTimeSourcing . get_build_path ( :dev ) # Or :test, Mix.env() MishkaInstaller.Installer.RunTimeSourcing . get_build_path ( )","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#get_build_path/1","title":"MishkaInstaller.Installer.RunTimeSourcing.get_build_path/1","type":"function"},{"doc":"Prepending path means that after getting and compiling a dependency, you can determine a made ebin folder as an item of dependencies. Hence, you need to move a compiled app with its sup-apps. This function calls Code.prepend_path/1 . Examples MishkaInstaller.Installer.RunTimeSourcing . prepend_compiled_apps ( [ &quot;test_app&quot; , &quot;mishka_developer_tools&quot; ] )","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#prepend_compiled_apps/1","title":"MishkaInstaller.Installer.RunTimeSourcing.prepend_compiled_apps/1","type":"function"},{"doc":"This function loads a .app file as binary. References: https://elixirforum.com/t/how-to-get-vsn-from-app-file/48132/2 https://github.com/elixir-lang/elixir/blob/main/lib/mix/lib/mix/tasks/compile.all.ex#L153-L154","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#read_app/2","title":"MishkaInstaller.Installer.RunTimeSourcing.read_app/2","type":"function"},{"doc":"This function helps the programmer to join the channel of this module( MishkaInstaller.Installer.RunTimeSourcing ) and receive the output as a broadcast in the form of {:run_time_sourcing, answer} . It uses Phoenix.PubSub.subscribe/2 . Examples # Subscribe to `MishkaInstaller.Installer.RunTimeSourcing` module MishkaInstaller.Installer.RunTimeSourcing . subscribe ( ) # Getting the answer as Pubsub for examples in LiveView @impl Phoenix.LiveView def handle_info ( { :run_time_sourcing , answer } , socket ) when is_binary ( answer ) do { :noreply , socket } end","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#subscribe/0","title":"MishkaInstaller.Installer.RunTimeSourcing.subscribe/0","type":"function"},{"doc":"This type can be used when you want to send an app name","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#t:app_name/0","title":"MishkaInstaller.Installer.RunTimeSourcing.app_name/0","type":"type"},{"doc":"This type can be used when you want to prepend a compiled-project","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#t:do_runtime/0","title":"MishkaInstaller.Installer.RunTimeSourcing.do_runtime/0","type":"type"},{"doc":"This type can be used when you want to ensure or start a project","ref":"MishkaInstaller.Installer.RunTimeSourcing.html#t:ensure/0","title":"MishkaInstaller.Installer.RunTimeSourcing.ensure/0","type":"type"},{"doc":"This module is for communication with Plugins table and has essential functions such as adding, editing, deleting, and displaying. This module is related to module MishkaInstaller.Database.PluginSchema .","ref":"MishkaInstaller.Plugin.html","title":"MishkaInstaller.Plugin","type":"module"},{"doc":"This is an aggregation function that includes editing or adding by name of plugin.","ref":"MishkaInstaller.Plugin.html#add_or_edit_by_name/1","title":"MishkaInstaller.Plugin.add_or_edit_by_name/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.create/1 .","ref":"MishkaInstaller.Plugin.html#create/1","title":"MishkaInstaller.Plugin.create/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_add/1 .","ref":"MishkaInstaller.Plugin.html#create/2","title":"MishkaInstaller.Plugin.create/2","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.delete/1 .","ref":"MishkaInstaller.Plugin.html#delete/1","title":"MishkaInstaller.Plugin.delete/1","type":"function"},{"doc":"Delete all the plugins of an event by an event name.","ref":"MishkaInstaller.Plugin.html#delete_plugins/1","title":"MishkaInstaller.Plugin.delete_plugins/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.edit/1 .","ref":"MishkaInstaller.Plugin.html#edit/1","title":"MishkaInstaller.Plugin.edit/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_edit/1 .","ref":"MishkaInstaller.Plugin.html#edit/2","title":"MishkaInstaller.Plugin.edit/2","type":"function"},{"doc":"","ref":"MishkaInstaller.Plugin.html#plugins/0","title":"MishkaInstaller.Plugin.plugins/0","type":"function"},{"doc":"Show plugins by event name or all the plugin.","ref":"MishkaInstaller.Plugin.html#plugins/1","title":"MishkaInstaller.Plugin.plugins/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.show_by_id/1 .","ref":"MishkaInstaller.Plugin.html#show_by_id/1","title":"MishkaInstaller.Plugin.show_by_id/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_get_by_field/2 .","ref":"MishkaInstaller.Plugin.html#show_by_name/1","title":"MishkaInstaller.Plugin.show_by_name/1","type":"function"},{"doc":"","ref":"MishkaInstaller.PluginDependTypeEnum.html","title":"MishkaInstaller.PluginDependTypeEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.PluginDependTypeEnum.html#cast/1","title":"MishkaInstaller.PluginDependTypeEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.PluginDependTypeEnum.html#dump/1","title":"MishkaInstaller.PluginDependTypeEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.PluginDependTypeEnum.html#embed_as/1","title":"MishkaInstaller.PluginDependTypeEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.PluginDependTypeEnum.html#equal?/2","title":"MishkaInstaller.PluginDependTypeEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.PluginDependTypeEnum.html#load/1","title":"MishkaInstaller.PluginDependTypeEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.PluginDependTypeEnum.html#type/0","title":"MishkaInstaller.PluginDependTypeEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.PluginDependTypeEnum.html#valid_value?/1","title":"MishkaInstaller.PluginDependTypeEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.PluginDependTypeEnum.html#t:t/0","title":"MishkaInstaller.PluginDependTypeEnum.t/0","type":"type"},{"doc":"This module provides a series of essential functions for storing plugins on ETS.","ref":"MishkaInstaller.PluginETS.html","title":"MishkaInstaller.PluginETS","type":"module"},{"doc":"Deleting a plug-in from the ETS table. Deleting plugins from the ETS table based on a specific event. Examples MishkaInstaller.PluginETS . delete ( module : &quot;TestModule.a_plugin&quot; ) # or MishkaInstaller.PluginETS . delete ( event : &quot;test_event&quot; )","ref":"MishkaInstaller.PluginETS.html#delete/1","title":"MishkaInstaller.PluginETS.delete/1","type":"function"},{"doc":"Getting a plug-in from the ETS table. Examples MishkaInstaller.PluginETS . get_all ( module : &quot;TestModule.a_plugin&quot; )","ref":"MishkaInstaller.PluginETS.html#get/1","title":"MishkaInstaller.PluginETS.get/1","type":"function"},{"doc":"Getting all plug-ins from the ETS table. Examples MishkaInstaller.PluginETS . get_all ( event : &quot;test_event&quot; )","ref":"MishkaInstaller.PluginETS.html#get_all/1","title":"MishkaInstaller.PluginETS.get_all/1","type":"function"},{"doc":"Storing a plug-in on the ETS table. Examples event = % MishkaInstaller.PluginState { name : &quot;MishkaUser.SuccessLogin&quot; , event : Atom . to_string ( @ref ) , priority : 1 } MishkaInstaller.PluginETS . push ( event )","ref":"MishkaInstaller.PluginETS.html#push/1","title":"MishkaInstaller.PluginETS.push/1","type":"function"},{"doc":"","ref":"MishkaInstaller.PluginETS.html#start_link/1","title":"MishkaInstaller.PluginETS.start_link/1","type":"function"},{"doc":"Initializing ETS table with database Examples MishkaInstaller.PluginETS . sync_with_database ( )","ref":"MishkaInstaller.PluginETS.html#sync_with_database/0","title":"MishkaInstaller.PluginETS.sync_with_database/0","type":"function"},{"doc":"This module served as the first layer in the domain of plugin state management in earlier versions; however, following optimization using ETS, it is now regarded as the main structure in the second layer. If a developer chooses to construct a custom plugin by using the use MishkaInstaller.Hook directive, then the developer actually implements this module as the first layer to register a plugin and the second layer as a supervisor. The scope of a plugin's state management is not restricted to the automatically specified duties performed by the MishkaInstaller ; for instance, it provides developers with a temporary state and offers them the freedom to act in accordance with whatever method they choose. Each plugin should have these parameters defstruct [ :name , :event , priority : 1 , status : :started , depend_type : :soft , depends : [ ] , extra : [ ] , parent_pid : nil ] Module communication process of MishkaInstaller.PluginState + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | + -- -- -- + MishkaInstaller.PluginStateDynamicSupervisor | | | | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + -- -- ^ -- -- + | | | | | | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | | | + -- -- -- &gt; PluginStateRegistry | | | | | | | + -- -- -- -- ^ -- -- -- -- -- -- -- - + | | | | | | | | | | | | | | | + -- -- -- -- -- -- -- -- -- -- v -- -- + -- -- - + | | | | | MishkaInstaller.PluginState | + -- -- -- -- + | + -- -- -- -- -- -- -- -- -- -- + -- -- -- -- ^ - + | | | | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | | | MishkaInstaller.PluginETS &lt;- -- -- - + | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | + -- -- -- -- -- -- -- -- -- -- + - + | | + -- -- -- -- -- -- - + MishkaInstaller.Hook | | | | | + -- -- -- -- -- -- -- -- -- -- -- + | | + -- -- -- -- - v -- -- -- -- -- -- -- -- -- -- -- + | | | Behaviour References | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- +","ref":"MishkaInstaller.PluginState.html","title":"MishkaInstaller.PluginState","type":"module"},{"doc":"Delete a plugin or plugins based on a specific event from the state. Examples MishkaInstaller.PluginState . delete ( module : &quot;PluginTest&quot; ) # or MishkaInstaller.PluginState . delete ( event : &quot;EventTest&quot; )","ref":"MishkaInstaller.PluginState.html#delete/1","title":"MishkaInstaller.PluginState.delete/1","type":"function"},{"doc":"Terminate a PID from the supervisor directly. Examples MishkaInstaller.PluginState . delete_child ( module : &quot;PluginTest&quot; )","ref":"MishkaInstaller.PluginState.html#delete_child/1","title":"MishkaInstaller.PluginState.delete_child/1","type":"function"},{"doc":"It gets a plugin information from the state. Examples MishkaInstaller.PluginState . get ( module : &quot;PluginTest&quot; )","ref":"MishkaInstaller.PluginState.html#get/1","title":"MishkaInstaller.PluginState.get/1","type":"function"},{"doc":"This function gets all information of plugins which are pushed on the state. Examples MishkaInstaller.PluginState . get_all ( )","ref":"MishkaInstaller.PluginState.html#get_all/0","title":"MishkaInstaller.PluginState.get_all/0","type":"function"},{"doc":"This function gets all information of plugins which are under a specific event. Examples MishkaInstaller.PluginState . get_all ( event : &quot;event_test&quot; )","ref":"MishkaInstaller.PluginState.html#get_all/1","title":"MishkaInstaller.PluginState.get_all/1","type":"function"},{"doc":"This function helps you to create the state of a plugin. Please see plugin/0 type documents. This function does not wait for a response. Examples plugin = % MishkaInstaller.PluginState { name : &quot;unnested_plugin_five&quot; , event : &quot;nested_event_one&quot; , depend_type : :hard , depends : [ &quot;unnested_plugin_four&quot; ] } MishkaInstaller.PluginState . push ( plugin )","ref":"MishkaInstaller.PluginState.html#push/1","title":"MishkaInstaller.PluginState.push/1","type":"function"},{"doc":"This function does the same thing as the push/1 function, except that it waits for a response.","ref":"MishkaInstaller.PluginState.html#push_call/1","title":"MishkaInstaller.PluginState.push_call/1","type":"function"},{"doc":"You should in no way use this function in its direct form. The supervisor coverage needs to run before using this function since it will establish a state for your plugin and save its PID in the registry. Make use of the function named MishkaInstaller.PluginStateDynamicSupervisor.start_job/1 .","ref":"MishkaInstaller.PluginState.html#start_link/1","title":"MishkaInstaller.PluginState.start_link/1","type":"function"},{"doc":"Stop a plugin state. Examples MishkaInstaller.PluginState . stop ( module : PluginTest ) # or MishkaInstaller.PluginState . stop ( event : &quot;event_test&quot; )","ref":"MishkaInstaller.PluginState.html#stop/1","title":"MishkaInstaller.PluginState.stop/1","type":"function"},{"doc":"Terminate all PIDs of the plugin state from the supervisor directly. Examples MishkaInstaller.PluginState . terminate_all_pids ( )","ref":"MishkaInstaller.PluginState.html#terminate_all_pids/0","title":"MishkaInstaller.PluginState.terminate_all_pids/0","type":"function"},{"doc":"This type can be used when you want to introduce an event name","ref":"MishkaInstaller.PluginState.html#t:event_name/0","title":"MishkaInstaller.PluginState.event_name/0","type":"type"},{"doc":"This type can be used when you want to introduce an event owner extension","ref":"MishkaInstaller.PluginState.html#t:extension/0","title":"MishkaInstaller.PluginState.extension/0","type":"type"},{"doc":"This type can be used when you want to introduce an ID of a plugin","ref":"MishkaInstaller.PluginState.html#t:id/0","title":"MishkaInstaller.PluginState.id/0","type":"type"},{"doc":"This type can be used when you want to introduce an plugin name","ref":"MishkaInstaller.PluginState.html#t:module_name/0","title":"MishkaInstaller.PluginState.module_name/0","type":"type"},{"doc":"This type can be used when you want to introduce the parameters of a plugin","ref":"MishkaInstaller.PluginState.html#t:params/0","title":"MishkaInstaller.PluginState.params/0","type":"type"},{"doc":"This type can be used when you want to introduce an event","ref":"MishkaInstaller.PluginState.html#t:plugin/0","title":"MishkaInstaller.PluginState.plugin/0","type":"type"},{"doc":"This type can be used when you want to introduce an event","ref":"MishkaInstaller.PluginState.html#t:t/0","title":"MishkaInstaller.PluginState.t/0","type":"type"},{"doc":"This module supervises the states created during the registration of each plugin. Module communication process of this module + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | + -- -- -- + MishkaInstaller.PluginStateDynamicSupervisor | | | | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- + -- -- ^ -- -- + | | | | | | | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | | | + -- -- -- &gt; PluginStateRegistry | | | | | | | + -- -- -- -- ^ -- -- -- -- -- -- -- -- - + | | | | | | | | | | | | | | | + -- -- -- -- -- -- -- -- -- -- v -- -- + -- -- - + | | | | | MishkaInstaller.PluginState | + -- -- -- -- + | + -- -- -- -- -- -- -- -- -- -- + -- -- -- -- -- + | | | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- + | | | | | MishkaInstaller.PluginETS &lt;- -- -- - + | | + -- -- -- -- -- -- -- -- -- -- -- -- -- -- +","ref":"MishkaInstaller.PluginStateDynamicSupervisor.html","title":"MishkaInstaller.PluginStateDynamicSupervisor","type":"module"},{"doc":"Get PID based on the name of a plugin from PluginStateRegistry Registry. Examples MishkaInstaller.PluginStateDynamicSupervisor . get_plugin_pid ( &quot;Plugin.TestName&quot; )","ref":"MishkaInstaller.PluginStateDynamicSupervisor.html#get_plugin_pid/1","title":"MishkaInstaller.PluginStateDynamicSupervisor.get_plugin_pid/1","type":"function"},{"doc":"Show all PIDs of PluginStateDynamicSupervisor module from PluginStateRegistry Registry. Examples MishkaInstaller.PluginStateDynamicSupervisor . running_imports ( )","ref":"MishkaInstaller.PluginStateDynamicSupervisor.html#running_imports/0","title":"MishkaInstaller.PluginStateDynamicSupervisor.running_imports/0","type":"function"},{"doc":"Show all PIDs of PluginStateDynamicSupervisor module based on a specific event from PluginStateRegistry Registry. Examples MishkaInstaller.PluginStateDynamicSupervisor . running_imports ( &quot;event_test_name&quot; )","ref":"MishkaInstaller.PluginStateDynamicSupervisor.html#running_imports/1","title":"MishkaInstaller.PluginStateDynamicSupervisor.running_imports/1","type":"function"},{"doc":"Start supervising plugin States.","ref":"MishkaInstaller.PluginStateDynamicSupervisor.html#start_job/1","title":"MishkaInstaller.PluginStateDynamicSupervisor.start_job/1","type":"function"},{"doc":"You are able to terminate all children that this module is responsible for supervising with the assistance of this function. Examples MishkaInstaller.PluginStateDynamicSupervisor . terminate_childeren ( )","ref":"MishkaInstaller.PluginStateDynamicSupervisor.html#terminate_childeren/0","title":"MishkaInstaller.PluginStateDynamicSupervisor.terminate_childeren/0","type":"function"},{"doc":"","ref":"MishkaInstaller.PluginStatusEnum.html","title":"MishkaInstaller.PluginStatusEnum","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"MishkaInstaller.PluginStatusEnum.html#cast/1","title":"MishkaInstaller.PluginStatusEnum.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"MishkaInstaller.PluginStatusEnum.html#dump/1","title":"MishkaInstaller.PluginStatusEnum.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"MishkaInstaller.PluginStatusEnum.html#embed_as/1","title":"MishkaInstaller.PluginStatusEnum.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"MishkaInstaller.PluginStatusEnum.html#equal?/2","title":"MishkaInstaller.PluginStatusEnum.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"MishkaInstaller.PluginStatusEnum.html#load/1","title":"MishkaInstaller.PluginStatusEnum.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"MishkaInstaller.PluginStatusEnum.html#type/0","title":"MishkaInstaller.PluginStatusEnum.type/0","type":"function"},{"doc":"","ref":"MishkaInstaller.PluginStatusEnum.html#valid_value?/1","title":"MishkaInstaller.PluginStatusEnum.valid_value?/1","type":"function"},{"doc":"","ref":"MishkaInstaller.PluginStatusEnum.html#t:t/0","title":"MishkaInstaller.PluginStatusEnum.t/0","type":"type"},{"doc":"Note : Please do not use it, it will be changed in the next version","ref":"MishkaInstaller.Reference.OnAfterDependency.html","title":"MishkaInstaller.Reference.OnAfterDependency","type":"behaviour"},{"doc":"This Callback can be used when you want to call a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#c:call/1","title":"MishkaInstaller.Reference.OnAfterDependency.call/1","type":"callback"},{"doc":"This Callback can be used when you want to delete a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#c:delete/1","title":"MishkaInstaller.Reference.OnAfterDependency.delete/1","type":"callback"},{"doc":"This Callback can be used when you want to register a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#c:initial/1","title":"MishkaInstaller.Reference.OnAfterDependency.initial/1","type":"callback"},{"doc":"This Callback can be used when you want to restart a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#c:restart/1","title":"MishkaInstaller.Reference.OnAfterDependency.restart/1","type":"callback"},{"doc":"This Callback can be used when you want to start a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#c:start/1","title":"MishkaInstaller.Reference.OnAfterDependency.start/1","type":"callback"},{"doc":"This Callback can be used when you want to stop a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#c:stop/1","title":"MishkaInstaller.Reference.OnAfterDependency.stop/1","type":"callback"},{"doc":"This Callback can be used when you want to unregister a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#c:unregister/1","title":"MishkaInstaller.Reference.OnAfterDependency.unregister/1","type":"callback"},{"doc":"This type can be used when you want to introduce an app","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:app/0","title":"MishkaInstaller.Reference.OnAfterDependency.app/0","type":"type"},{"doc":"This type can be used when you want to show the output of optional callbacks","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:optional_callbacks/0","title":"MishkaInstaller.Reference.OnAfterDependency.optional_callbacks/0","type":"type"},{"doc":"This type can be used when you want to introduce output of finished compiling/installing","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:output/0","title":"MishkaInstaller.Reference.OnAfterDependency.output/0","type":"type"},{"doc":"This type can be used when you want to introduce a plugin output","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:reason/0","title":"MishkaInstaller.Reference.OnAfterDependency.reason/0","type":"type"},{"doc":"This type can be used when you want to introduce an app's reference name","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:ref/0","title":"MishkaInstaller.Reference.OnAfterDependency.ref/0","type":"type"},{"doc":"This type can be used when you want to register an app","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:registerd_info/0","title":"MishkaInstaller.Reference.OnAfterDependency.registerd_info/0","type":"type"},{"doc":"This type can be used when you want to introduce an app as a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:state/0","title":"MishkaInstaller.Reference.OnAfterDependency.state/0","type":"type"},{"doc":"This type can be used when you want to introduce an app's status","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:status/0","title":"MishkaInstaller.Reference.OnAfterDependency.status/0","type":"type"},{"doc":"This type can be used when you want to introduce an app as a plugin","ref":"MishkaInstaller.Reference.OnAfterDependency.html#t:t/0","title":"MishkaInstaller.Reference.OnAfterDependency.t/0","type":"type"},{"doc":"Note : Please do not use it, it will be changed in the next version This event is kicked off anytime a plugin is moved into the installation or update stage of the process. In the event that a plugin from this area is carrying out the after completing all the above-mentioned procedures, the developer will have access to the output in real time. Note : Treat this event as a no return flag while analyzing it. It is currently being renovated, and in the future it might look different.","ref":"MishkaInstaller.Reference.OnChangeDependency.html","title":"MishkaInstaller.Reference.OnChangeDependency","type":"behaviour"},{"doc":"This Callback can be used when you want to call a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#c:call/1","title":"MishkaInstaller.Reference.OnChangeDependency.call/1","type":"callback"},{"doc":"This Callback can be used when you want to delete a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#c:delete/1","title":"MishkaInstaller.Reference.OnChangeDependency.delete/1","type":"callback"},{"doc":"This Callback can be used when you want to register a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#c:initial/1","title":"MishkaInstaller.Reference.OnChangeDependency.initial/1","type":"callback"},{"doc":"This Callback can be used when you want to restart a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#c:restart/1","title":"MishkaInstaller.Reference.OnChangeDependency.restart/1","type":"callback"},{"doc":"This Callback can be used when you want to start a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#c:start/1","title":"MishkaInstaller.Reference.OnChangeDependency.start/1","type":"callback"},{"doc":"This Callback can be used when you want to stop a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#c:stop/1","title":"MishkaInstaller.Reference.OnChangeDependency.stop/1","type":"callback"},{"doc":"This Callback can be used when you want to unregister a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#c:unregister/1","title":"MishkaInstaller.Reference.OnChangeDependency.unregister/1","type":"callback"},{"doc":"This type can be used when you want to introduce an app","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:app/0","title":"MishkaInstaller.Reference.OnChangeDependency.app/0","type":"type"},{"doc":"This type can be used when you want to show the output of optional callbacks","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:optional_callbacks/0","title":"MishkaInstaller.Reference.OnChangeDependency.optional_callbacks/0","type":"type"},{"doc":"This type can be used when you want to introduce each line of compiling/installing","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:output/0","title":"MishkaInstaller.Reference.OnChangeDependency.output/0","type":"type"},{"doc":"This type can be used when you want to introduce a plugin output","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:reason/0","title":"MishkaInstaller.Reference.OnChangeDependency.reason/0","type":"type"},{"doc":"This type can be used when you want to introduce an app's reference name","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:ref/0","title":"MishkaInstaller.Reference.OnChangeDependency.ref/0","type":"type"},{"doc":"This type can be used when you want to register an app","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:registerd_info/0","title":"MishkaInstaller.Reference.OnChangeDependency.registerd_info/0","type":"type"},{"doc":"This type can be used when you want to introduce an app as a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:state/0","title":"MishkaInstaller.Reference.OnChangeDependency.state/0","type":"type"},{"doc":"This type can be used when you want to introduce an app's status","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:status/0","title":"MishkaInstaller.Reference.OnChangeDependency.status/0","type":"type"},{"doc":"This type can be used when you want to introduce an app as a plugin","ref":"MishkaInstaller.Reference.OnChangeDependency.html#t:t/0","title":"MishkaInstaller.Reference.OnChangeDependency.t/0","type":"type"},{"doc":"Note : Please do not use it, it will be changed in the next version","ref":"MishkaInstaller.Reference.OnInit.html","title":"MishkaInstaller.Reference.OnInit","type":"module"},{"doc":"This module is for communication with Settings table and has essential functions such as adding, editing, deleting, and displaying. This module is related to module MishkaInstaller.Database.SettingSchema .","ref":"MishkaInstaller.Setting.html","title":"MishkaInstaller.Setting","type":"module"},{"doc":"This is an aggregation function that includes editing or adding by name.","ref":"MishkaInstaller.Setting.html#add_or_edit_by_name/1","title":"MishkaInstaller.Setting.add_or_edit_by_name/1","type":"function"},{"doc":"","ref":"MishkaInstaller.Setting.html#allowed_fields/1","title":"MishkaInstaller.Setting.allowed_fields/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.create/1 .","ref":"MishkaInstaller.Setting.html#create/1","title":"MishkaInstaller.Setting.create/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_add/1 .","ref":"MishkaInstaller.Setting.html#create/2","title":"MishkaInstaller.Setting.create/2","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.delete/1 .","ref":"MishkaInstaller.Setting.html#delete/1","title":"MishkaInstaller.Setting.delete/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.edit/1 .","ref":"MishkaInstaller.Setting.html#edit/1","title":"MishkaInstaller.Setting.edit/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_edit/1 .","ref":"MishkaInstaller.Setting.html#edit/2","title":"MishkaInstaller.Setting.edit/2","type":"function"},{"doc":"","ref":"MishkaInstaller.Setting.html#settings/0","title":"MishkaInstaller.Setting.settings/0","type":"function"},{"doc":"Show all settings.","ref":"MishkaInstaller.Setting.html#settings/1","title":"MishkaInstaller.Setting.settings/1","type":"function"},{"doc":"Callback implementation for MishkaDeveloperTools.DB.CRUD.show_by_id/1 .","ref":"MishkaInstaller.Setting.html#show_by_id/1","title":"MishkaInstaller.Setting.show_by_id/1","type":"function"},{"doc":"See MishkaDeveloperTools.DB.CRUD.crud_get_by_field/2 .","ref":"MishkaInstaller.Setting.html#show_by_name/1","title":"MishkaInstaller.Setting.show_by_name/1","type":"function"},{"doc":"If you want to get the latest changes from the Settings table of your database, this function can help you to be subscribed.","ref":"MishkaInstaller.Setting.html#subscribe/0","title":"MishkaInstaller.Setting.subscribe/0","type":"function"},{"doc":"Generates MishkaInstallers required migrations.","ref":"Mix.Tasks.MishkaInstaller.Db.Gen.Migration.html","title":"Mix.Tasks.MishkaInstaller.Db.Gen.Migration","type":"task"},{"doc":"","ref":"Mix.Tasks.MishkaInstaller.Db.Gen.Migration.html#generated_file/3","title":"Mix.Tasks.MishkaInstaller.Db.Gen.Migration.generated_file/3","type":"function"},{"doc":"","ref":"Mix.Tasks.MishkaInstaller.Db.Gen.Migration.html#timestamp/0","title":"Mix.Tasks.MishkaInstaller.Db.Gen.Migration.timestamp/0","type":"function"},{"doc":"","ref":"readme.html","title":"Elixir programming language plugin management system","type":"extras"},{"doc":"Imagine you are going to make an application that will have many plugins built for it in the future. But the fact that many manipulations will be made on your source code makes it difficult to maintain the application. For example, you present a content management system for your users, and now they need to activate a section for registration and SMS ; the system allows you to present your desired input/output absolutely plugin oriented to your users and makes it possible for the developers to write their required applications beyond the core source code. We have used this library in the Mishka content management system . NOTICE: Do not use the master branch; this library is under heavy development. Expect version 0.0.4, and for using the new features, please wait until a new release is out. Plugin management system theory and installation of Elixir libraries at runtime The functionality of this library can be conceptualized as an architectural potential that is composed of two primary components, which are as follows: Event management Managing removal and installation of Elixir plugins without downtime . When a programmer uses this library for his own software development, we sought to ensure that in addition to the established capabilities, he also has access to a set of appropriate standards for software development that are based on preset behaviors that can be applied. This was our goal. It streamlines and organizes the work of a group working on a project while also facilitating the creation of software. Error control and tree structure, which enable us to develop a system that is robust and trustworthy, are two of the guiding ideas behind the construction of this library, which has garnered attention from people all around the world. The MishkaInstaller library can be created in various systems, and it provides fundamental capabilities such as the management of plugin states and the application of standard behaviors. These features can all be accessed by specified hooks in the library.","ref":"readme.html#build-purpose","title":"Elixir programming language plugin management system - Build purpose","type":"extras"},{"doc":"In this section, you can define a series of events for each event , for example: after successful registration or unsuccessful purchase from “the store”, and for each event , put a set of callbacks in one module. After completing this step, when the user wants to create his own plugin, the @behaviour module will call you in its action module. This helps you have a regular and error-free system, and the library uses an almost integrated structure in all of its events.","ref":"readme.html#behaviors-and-events","title":"Elixir programming language plugin management system - Behaviors and events","type":"extras"},{"doc":"In Mishka Elixir Plugin Management Library, a series of action or hook functions are given to the developer of the main plugin or software, which helps build plugins outside the system and convert software sections into separate events . Some of the functions of this module include the following: Registering a plugin outside of the system in database and ram state Removing plugin from database and state Restoring plugin Successful pause of plugin Hook plugin Search among the events And other functions that help both the mother software become an event-driven system and the developer can build the desired plugin or extension for different parts of the software and install it on the system as a separate package. This package can also be published in hex .","ref":"readme.html#hook-with-priority","title":"Elixir programming language plugin management system - Hook with priority","type":"extras"},{"doc":"The Hook module manages a large part of this part, and the developer of the external plugin usually does not need it much. Still, this part creates a state on RAM for each plugin that is activated in a specific event and a dynamic supervisor for it. This allows us in case of an error in each plugin; the other plugins in the different events face no errors, and the system will try to restart with various strategies. It should be noted for more stability and data storage after registering a plugin in the system; This section also maintains a backup copy of the database and strategies for recall in the event in case of an error. But to speed up the calling of each plugin, the website always uses state .","ref":"readme.html#state-management-and-links-to-the-database-supporting-postgresql","title":"Elixir programming language plugin management system - State management and links to the database supporting PostgreSQL","type":"extras"},{"doc":"Through the use of event management, you are able to convert any portion of your program into a standalone event based on the specific requirements of the strategy, and you are also able to activate an endless number of modules or plugins for each event. However, if you do not perform installation at runtime, you will need to ensure that you call all of the necessary plugins in addition to the primary source when you start the software. One example of this would be installing an Elixir library in the mix.exs file. By utilizing this capability, you will be able to add your program to the system and manage it after adding it, even if your software is already operating. The following are examples of management facilities that may be included: Register a plugin for a specified event Activate the plugin for the installation Put an end to the installation of plugins Resetting the configuration plugin used during installation Uninstall the currently active plugin. Manage the plugin's requirements after they have been installed. Keeping an eye on the graphic panel and demonstrating it to the site managers And there are other scenarios that are known as APIs or Hooks to the software developer and management, and making use of them is a pretty straightforward process. It is important to note that this capability does not involve Erlang's hot coding and that it can only be used to install an Elixir library. Additionally, it is still in the process of being developed and is now in an experimental stage. If you use the software, you need to make sure you have a backup of it. At the moment, it is merely in the testing phase of its development, which consists of trial and error. To use this section, please read the documentation of this library","ref":"readme.html#managing-removal-and-installation-of-elixir-plugins-without-downtime","title":"Elixir programming language plugin management system - Managing removal and installation of Elixir plugins without downtime","type":"extras"},{"doc":"It should be noted that this library must be installed in two parts of the plugin and the software that wants to display the plugins, and due to its small dependencies, it does not cause any problems. To install, just add this library to your &quot;mix.exs&quot; in the &quot;deps&quot; function as follows: def deps do [ { :mishka_installer , &quot;~&gt; 0.0.4&quot; } ] end","ref":"readme.html#installing-the-library","title":"Elixir programming language plugin management system - Installing the library:","type":"extras"},{"doc":"After installing this library, you must first install the required database of this package on your website, for which a mix task has been created, which is enough to load it once in your terminal, in the project path before the start. mix mishka_installer . db . gen . migration After implementing the above sections, you must first implement events in your main software and place the call function from the Hook module there to call all the plugins activated in the event you want based on priority. And give the state you want, to these plugins in order, and the output you expect will eventually be generated. For example, you can see the mentioned description in a function controller in phoenix after a successful registration as the following: def login ( conn , %{ &quot;user&quot; =&gt; %{ &quot;email&quot; =&gt; email , &quot;password&quot; =&gt; password } } = _params ) do # If your conditions are passed we call an event and pass it a struct of entries # which our developers need to create plugin with this information state = % MishkaInstaller.Reference.OnUserAfterLogin { conn : conn , endpoint : :html , ip : user_ip , type : :email , user_info : user_info } hook = MishkaInstaller.Hook . call ( event : &quot;on_user_after_login&quot; , state : state ) hook . conn |&gt; renew_session ( ) |&gt; put_session ( :user_id , user_info . id ) |&gt; put_flash ( :info , &quot;You entered to our world, well played.&quot; ) |&gt; redirect ( to : &quot;/home&quot; ) end Now the event is ready in the part where you need to allow the developer to make his own plugins for it. And it's time to write a plugin for this section. This is very simple. Consider the following example: defmodule MishkaUser.SuccessLogin do alias MishkaInstaller.Reference.OnUserAfterLogin use MishkaInstaller.Hook , module : __MODULE__ , behaviour : OnUserAfterLogin , event : :on_user_after_login , initial : [ ] @spec initial ( list ( ) ) :: { :ok , OnUserAfterLogin . ref ( ) , list ( ) } def initial ( args ) do event = % PluginState { name : &quot;MishkaUser.SuccessLogin&quot; , event : Atom . to_string ( @ref ) , priority : 1 } Hook . register ( event : event ) { :ok , @ref , args } end @spec call ( OnUserAfterLogin . t ( ) ) :: { :reply , OnUserAfterLogin . t ( ) } def call ( % OnUserAfterLogin { } = state ) do new_state = Your_Code_Or_Function { :reply , new_state } end end As you can see in the above, we used MishkaInstaller.Reference.OnUserAfterLogin in order to activate behavior which has a few callback in it, and you can see here . There should be two main functions in each plugin, namely initial and also call . In the first function, we introduce our plugin, and in the second function, whenever the action function calls this special event for which the plugin is written, based on priority. This plugin is also called. But what is important is the final output of the call function. This output may be the input of other plugins with higher priorities. The order of the plugins is from small to large, and if several plugins are registered for a number, it is sorted by name in the second parameter. And it should be noted that in any case, if you did not want this state to go to other plugins and the last output is returned in the same plugin, and you can replace {:reply, :halt, new_state} with {:reply, new_state} . Subsequent plugins with higher priorities are not counted, and the loop ends here. Notice that a Genserver will be made based on each plugin name without a supervisor, which can be used for temporary memory in the case when the __using__ function is used as above, which results in the following option: use MishkaInstaller.Hook , module : __MODULE__ , behaviour : OnUserAfterLogin , event : :on_user_after_login , initial : [ ] The last two step to use the plugin you have to put it in your Application module so that whenever the server is turned off and on, the plugin is run again and if it is not registered, a copy of its support will be provided once in the database. children = [ %{ id : YOUR_PLUGIN_MODULE , start : { YOUR_PLUGIN_MODULE , :start_link , [ [ ] ] } } ] And add these config in your project like /config/config.exs config :mishka_installer , :basic , repo : YOUR_Repo , pubsub : YOUR_PUBSUB or nil , html_router : YOUR_WEBSITE_ROUTER_MODULE , project_path : YOUR_PROJECT_PATH , mix : YOUR_MIX_MODULE , mix_path : YOUR_MIX_EXS_PATH , gettext : YOUR_GETTEXT If you are using Phoenix as developer mode, please disable live_reload in dev.exs . Please add reloadable_apps: [:mishka_installer] to your endpoint config in config.exs file. Because there are a lot of moving elements in this plugin, you need to read the documentation before using it. You can see our recommendations and other colleagues in the Proposal repository, and if you have a request or idea, send us the full description. Please help us by submitting suggestions and reviewing the project so that Mishka Group can produce more products and provide them to programmers and webmasters, and online software.","ref":"readme.html#using-the-library-for-extension-creation-and-event-activation","title":"Elixir programming language plugin management system - Using the library for extension creation and event activation:","type":"extras"}]